require 'sketchup.rb'
#-----------------------------------------------------------------------------
def create_cab

    prompts = ["Cabinet Width", "Cabinet Height", "Cabinet Depth","With Kick?"]
    values = [100.cm, 100.cm, 60.cm , 10.cm ]
    thick = 3.cm  #<----panel thickness
    results = inputbox prompts, values, "Cabinet Dimensions"
    width, height, depth, kick = results
    if (kick <= 0.0.cm)
       then kick = 0.01.cm
    end
#-----------------------------------------------------------------------------
    model = Sketchup.active_model
    model.start_operation "Create Cab"
    entities = model.active_entities
    group = entities.add_group
    entities = group.entities
    
    ls=[]   #left panel
    ls[0] = [0, kick+thick, 0]
    ls[1] = [0, depth, 0]
    ls[2] = [0, depth, height-thick]
    ls[3] = [0, thick, height-thick]
    ls[4] = [0, thick, kick]
    ls[5] = [0, kick+thick, kick]
    ls_base = entities.add_face ls
    ls_base.pushpull thick

    x = width-thick
    rs=[]   #right panel
    rs[0] = [x, kick+thick, 0]
    rs[1] = [x, depth, 0]
    rs[2] = [x, depth, height-thick]
    rs[3] = [x, thick, height-thick]
    rs[4] = [x, thick, kick]
    rs[5] = [x, kick+thick, kick]
    rs_base = entities.add_face rs
    rs_base.pushpull thick

    y = width/2-thick/2
    rs=[]   #center panel
    rs[0] = [y, kick+thick, 0]
    rs[1] = [y, depth, 0]
    rs[2] = [y, depth, height-thick]
    rs[3] = [y, thick, height-thick]
    rs[4] = [y, thick, kick]
    rs[5] = [y, kick+thick, kick]
    rs_base = entities.add_face rs
    rs_base.pushpull thick

    top=[]   #top 
    top[0] = [0, thick, height]
    top[1] = [0, depth, height]
    top[2] = [0, depth, height-thick]
    top[3] = [0, thick, height-thick]
    top_base = entities.add_face top
    top_base.pushpull -width

    btm=[]   #bottom shelf
    btm[0] = [thick, thick, kick]
    btm[1] = [thick, depth, kick]
    btm[2] = [thick, depth, kick+thick]
    btm[3] = [thick, thick, kick+thick]
    btm_base = entities.add_face btm
    btm_base.pushpull width-thick-thick
    
    mid=[]   #middle shelf
    mid[0] = [thick, thick, (height+kick)/2]
    mid[1] = [thick, depth, (height+kick)/2]
    mid[2] = [thick, depth, (height+kick)/2+thick]
    mid[3] = [thick, thick, (height+kick)/2+thick]
    mid_base = entities.add_face mid
    mid_base.pushpull width-thick-thick

    kickf=[]   #kicktoe panel front
    kickf[0] = [0, kick, 0]
    kickf[1] = [0, kick+thick, 0]
    kickf[2] = [0, kick+thick, kick]
    kickf[3] = [0, kick, kick]
    kickf_base = entities.add_face kickf 
    kickf_base.pushpull -width

    kickb=[]   #kicktoe panel back
    kickb[0] = [thick, depth, 0]
    kickb[1] = [thick, depth-thick, 0]
    kickb[2] = [thick, depth-thick, kick]
    kickb[3] = [thick, depth, kick]
    kickb_base = entities.add_face kickb 
    kickb_base.pushpull width-thick-thick
#-----------------------------------------------------------------------------
    view = model.active_view 
    view.zoom_extents 
#-----------------------------------------------------------------------------
    prompts = ["Door Height", "Top Rail Width", "Bottom Rail Width", "Stile Width" ]
    values = [100.cm, 10.cm, 10.cm, 5.cm]
    results = inputbox prompts, values, "Door Frame Dimensions"   
    height, top, btm, sw = results
#----------------------------------Do Left Door        
    ld=[]    #left style, left door
    ld[0] = [0, 0, kick]
    ld[1] = [0, 0, height]
    ld[2] = [0, thick, height]
    ld[3] = [0, thick, kick]
    ld_base = entities.add_face ld 
    ld_base.pushpull -sw
    
    x = width/2-sw
    ld=[]    #right style, left door
    ld[0] = [x, 0, kick]
    ld[1] = [x, 0, height]
    ld[2] = [x, thick, height]
    ld[3] = [x, thick, kick]
    ld_base = entities.add_face ld 
    ld_base.pushpull -sw
 
    x = sw
    ld=[]    #top rail, left door
    ld[0] = [x, 0, height-top]
    ld[1] = [x, thick,height-top]
    ld[2] = [x, thick, height]
    ld[3] = [x, 0, height]
    ld_base = entities.add_face ld
    ld_base.pushpull width/2-sw-sw
    
    x = sw
    ld=[]    #btm rail, left door
    ld[0] = [x, 0, kick]
    ld[1] = [x, 0, kick+btm]
    ld[2] = [x, thick, kick+btm]
    ld[3] = [x, thick, kick]
    ld_base = entities.add_face ld 
    ld_base.pushpull width/2-sw-sw

    x = sw
    ld=[]    #glazing panel, left door
    ld[0] = [x, thick/2, height-top]
    ld[1] = [x, thick, height-top]
    ld[2] = [x, thick, kick+btm]
    ld[3] = [x, thick/2, kick+btm]
    ld_base = entities.add_face ld 
    ld_base.material = Sketchup::Color.new (236,201, 101)
    ld_base.material.alpha = 0.7 
    ld_base.pushpull width/2-sw-sw
#----------------------------------- Do Right Door
    x = width/2+sw
    ld=[]    #left style, right door
    ld[0] = [x, 0, kick]
    ld[1] = [x, 0, height]
    ld[2] = [x, thick, height]
    ld[3] = [x, thick, kick]
    ld_base = entities.add_face ld 
    ld_base.pushpull sw
    
    x = width-sw
    ld=[]    #right style, right door
    ld[0] = [x, 0, kick]
    ld[1] = [x, 0, height]
    ld[2] = [x, thick, height]
    ld[3] = [x, thick, kick]
    ld_base = entities.add_face ld 
    ld_base.pushpull -sw
 
    x = width-sw
    ld=[]    #top rail, right door
    ld[0] = [x, 0, height-top]
    ld[1] = [x, thick,height-top]
    ld[2] = [x, thick, height]
    ld[3] = [x, 0, height]
    ld_base = entities.add_face ld
    ld_base.pushpull width/2-sw-sw
    
    x = width-sw
    ld=[]    #btm rail, right door
    ld[0] = [x, 0, kick]
    ld[1] = [x, 0, kick+btm]
    ld[2] = [x, thick, kick+btm]
    ld[3] = [x, thick, kick]
    ld_base = entities.add_face ld 
    ld_base.pushpull width/2-sw-sw

    x = width-sw
    ld=[]    #glazing panel, right door
    ld[0] = [x, thick/2, height-top]
    ld[1] = [x, thick, height-top]
    ld[2] = [x, thick, kick+btm]
    ld[3] = [x, thick/2, kick+btm]
    ld_base = entities.add_face ld 
    ld_base.material = Sketchup::Color.new (236,201, 101)
    ld_base.material.alpha = 0.7 
    ld_base.pushpull width/2-sw-sw
#-----------------------------------------------------------------------------
    prompts = ["Counter Top Height", "Thickness", "Reveal"]
    values = [100.cm, 5.cm, 1.cm]
    results = inputbox prompts, values, "Countertop Optional"   
    height, th, reveal = results
          
    top=[]   #countertop 
    top[0] = [0, thick, height]
    top[1] = [0, thick, height+reveal]
    top[2] = [0, 0, height+reveal]
    top[3] = [0, 0, height+th]
    top[4] = [0, depth, height+th]
    top[5] = [0, depth, height]
    top_base = entities.add_face top
    top_base.pushpull -width
#-----------------------------------------------------------------------------
     model.commit_operation
end
#-----------------------------------------------------------------------------
if( not file_loaded?("Cab.rb") )
  
end
#-----------------------------------------------------------------------------
file_loaded("cab.rb")

require 'sketchup.rb'

def createSimpleBeam
    prompts = ["Beam Width","Beam Height","Beam length"]
    values = [10.cm, 20.cm, 220.cm]
    results = inputbox(prompts, values, "Beam Properties")
    
   
    myBeamWidth ,myBeamHeight,myBeamLength = results
    
    #get the model 
    model = Sketchup.active_model
    
    #get the list of all components
    definitions = model.definitions
    myBeam=nil
    
    for myDef in definitions
        if myDef.name == (myBeamWidth.to_s + "x" + myBeamHeight.to_s + "x" + myBeamLength.to_s + " Beam")
            myBeam= myDef
        end
    end
        
    
    if (myBeam ==nil )
        #make it be one single undo operation
        model.start_operation("Create beam")
       #add a new component
        myBeam=definitions.add
    
        #get list of all simple geometrys in the component
        # (right now its empty cause we just created the component)
        entities = myBeam.entities
    
        #now to build the beam
        #make the 'edge' face
        edgeFace = entities.add_face([0,0,0],[0,myBeamWidth - 0.5,0],[0,myBeamWidth - 0.5,myBeamHeight - 0.5],[0,0,myBeamHeight - 0.5])
        edgeFace.pushpull myBeamLength
    
        myBeam.name= myBeamWidth.to_s + "x" + myBeamHeight.to_s + "x" + myBeamLength.to_s + " Beam"
        model.commit_operation
        
        #make a attribute dictionary for use elswhere
        myGuid= myBeam.guid
        myBeam.set_attribute myGuid, "type", "beam"
        myBeam.set_attribute myGuid, "length", myBeamLength.to_s
        myBeam.set_attribute myGuid, "width", myBeamWidth.to_s
        myBeam.set_attribute myGuid, "height", myBeamHeight.to_s
        UI.messagebox myBeam
        UI.messagebox myGuid
        
        
    end
    Sketchup.active_model.place_component myBeam, false
   
    
    
end

def createSimplePly
    prompts = ["Ply Width","Ply Length","Ply Thickness"]
    values = [124.cm, 248.cm, 22.mm]
    results = inputbox(prompts, values, "Plywood Properties")
    
   
    myWidth,myLength,myDepth = results
    
    #get the model 
    model = Sketchup.active_model
    definitions = model.definitions
    
    myPly=0
    for myDef in definitions
        if myDef.name == (myWidth.to_s + "x" + myLength.to_s + "x" + myDepth.to_s + " Ply")
            myPly= myDef
        end
    end
            
        
    if (myPly == 0 )
        model.start_operation("Create Ply")
         myPly=definitions.add
         entities = myPly.entities
         edgeFace = entities.add_face([0,0,0],[0,myWidth,0],[0,myWidth,myLength],[0,0,myLength])
         edgeFace.pushpull myDepth
         myPly.name= myWidth.to_s + "x" + myLength.to_s + "x" + myDepth.to_s + " Ply"
        model.commit_operation
    end
    Sketchup.active_model.place_component myPly, false
end

#now for some context menu stuff

def isBeam
    ss=Sketchup.active_model.selection
    return nil if ss.count > 1
    myObj = ss.first
    return nil if not myObj.typename == "ComponentInstance"
    myObjDef = myObj.definition
    UI.messagebox myObjDef
    UI.messagebox myObjDef.guid
    myType = myObjDef.get_attribute( myObjDef.guid, "type")
    UI.messagebox myType
    return nil if myType == nil
    if (myType == "beam")
        return 1
    else 
        return nil
    end
end
    
    if( not file_loaded?("SimpleBeam.rb") )
    
end
#-----------------------------------------------------------------------------
file_loaded("SimpleBeam.rb")



# 2006-03-23
# Name :		Door Maker
# Description :		Makes doors with 4 copies of the leaf on 4 layers
#			Optional Kicker(s),Name Plate(s), Handles(s)
# Author :		PKR
# Usage :		Pick 'Door Maker' from 'Plug in Menu' menu,fill in the details,
#			and click anywhere over & over & over.....
#			
# Notes :
#			All variable specified at begining of script
#			Material colours and opacity specified in dm_add_paint at end of script
#			All Dims in mm
#
# Date :		2006-03-28
#
# To Be Done :
#			1. Door & a half
#			2. error checking, i.e. no Vision panel of leaf is too narrow
#
# History:
#			V 1.0	2006-03-28
#				First release - Only produces single doors
#			V 1.1	2006-03-29
#				Renamed all routines to start with 'dm_'
#				Removed unnecessary '_' from variable names
#				Groups have names assigned as they are created
#				Store & Restore users current layer at begining & end of main routine
#				Replaced If's with Case/When's
#				Turned the whole thing in to a class
#				Place door(s) anywhere
#			v 1.2	2006-03-31
#				Vision panel added
#				Individual materials only created if needed
#				Redesigned the panic bar to be more representational
#			v 1.3	2006-04-02
#				Longbar and vision panel no longer over lap
#				Changed the valables to non persistant (@'s) apart from the ones the user
#				picks in the dialog, these remain persistant ($'s)
#				Leaf now has its own origin and size variables ( step one to double doors)
#				Fixed 'Inward and 'Outward' descriptions - they were all over the place!
#				Double door option added to dialog, script now creates a leaf HALF the opening width ( step two to double doors)
#				Nested grouping working (thanks TIG)
#				Double doors working!!!
#			v 1.4	2006-04-03
#				Fixed a problem with the copied leaf's group being on the wrong layer
#			v 1.5	2006-04-03
#				Vision panel now disabled friendly, the bottom of the VP is the set to the bottom of the pushplate value (thanks TIG)
#			v 1.6	2006-04-03
#				Changed a couple of the default values
#				Fixed Major fault in the panic bolt 
#			v 1.7	2006-04-03
#				Changed dialog drop down list "Vision Panel" to "Panel"
#				Added 1x1 and 1x2 full size glass panels
#			v 1.8	2006-04-05
#				Renamed some variable AGAIN!!
#				Added some error handling Nameplate only if.... etc
#				Added solid panels to the 1x1 and 1x2 glass routines by NOT punching the holes
#				Door & a Half added - 4 sizes of master leaf
#			v 1.9	2006-04-07
#				Renamed variables  - Arrays = a_   Strings = s_    Values = v_    Dialog Items = d_
#				Restructured the code to replace the long 'x=a+b+c+d+e, y=a+b+c+d+e, z=a+b+c+d+e' with the array/clone/+= arrangement (Thanks Remi)
#				Added option to display 'Double Swing' to Swing Arc Style
#			v 2.0	2006-04-14
#				Added new profile to frame - 'Rebated + Architrave'
#				Added settable offset for leaf(s) - centred or flush with frame - default is flush
#				Added 'Port Hole' to the available panels
#
#
#
#	INWARD OPENING SIDE
#	  ++ +
#	  ++  ++
#	  ++    ++
#	  ++      ++
#	  ++        +
#	  ++         ++
#	  ++          +
#	  ++          ++
#	++              ++
#	+++            +++
#	+++            +++
#       OUTWARD OPENING SIDE
#
#
#	WHEN DEFINING POINT (IN PLAN OR ELEVATION]
#	THEY ARE DESCRIBED CLOCKWISE STARTING FROM BOTTOM LEFT
#
#		1++++++2	1+
#		+      +	+ ++
#	E.G.	+      +	+   ++
#		+      +	+     ++
#		0++++++3	0+++++++2
#

#-----------------------
require 'sketchup.rb'
#-----------------------

#-----------------------------------------------------------------------------------------------
class DM_Create		#### START OF CLASS ####
#-----------------------------------------------------------------------------------------------

	def initialize #initialize or activate - which one ???
	#-----------------------------------------------------------------------------------------------
	#Set default values
	#-----------------------------------------------------------------------------------------------
		$vp = Sketchup::InputPoint.new			#used in mouse routines to get/set/use the picked position
		$a_FOrigintemp = Sketchup::InputPoint.new		#used in mouse routines to get/set/use the picked position
		$displayed = false				#used in mouse routines to get/set/use the picked position
		$a_FOrigin=nil						#used in mouse routines to get/set/use the picked position

		#Layernames
		$s_LayerRoot = "05-" if not $s_LayerRoot	##Root name of created layers e.g. Fred-Frame,Bill-Frame etc
		@s_LayerDoorSet = "D-Doors"			#Layer for the frame and master group
		@s_LayerLeaf00 = "D-Leaf00"			#layer for the closed (0deg)leaf
		@s_LayerLeaf30 = "D-Leaf30"			#layer for the 30deg leaf
		@s_LayerLeaf60 = "D-Leaf60"			#layer for the 60deg leaf
		@s_LayerLeaf90 = "D-Leaf90"			#layer for the 90deg leaf
		@s_LayerFittings = "D-Fittings"			#layer for the handle, kicker, nameplate etc
		@s_LayerSwing = "D-Swing"			#layer for the arc showing the swing
		
		#Angle in rad's
		@v_Rad180 = 3.141592653589793			#180 degree angle = pi radians
		@v_Rad90 = @v_Rad180/2				#90 deg
		@v_Rad60 = @v_Rad180/3				#60 deg
		@v_Rad30 = @v_Rad180/6				#30 deg
		
		#DoorSet Defaults
		$s_DoorType = "Single" if not $s_DoorType	##Setable Door type - Single, Double etc
		@s_DSGrpName = "DM DoorSet"
		
		#Frame Defaults
		$v_FWidth = 910.mm if not $v_FWidth		##setable overall width of the frame
		$v_FHeight = 2100.mm if not $v_FHeight		##setable overall height of the frame
		$v_FDepth = 100.mm if not $v_FDepth		##setable depth of the frame (wall thickness?)
		$v_FThick = 50.mm if not $v_FThick		##setable width of the frame member
		@s_FMaterial = "Door-Frame"			#default colour fot the frame
		$s_FStyle = "Simple" if not $s_FStyle		##setable style for the frame
		@v_FRebate = 15.mm				#default rebate for the frame
		@s_FGrpName = "DM Frame"
		
		#Leaf Defaults
		$v_LDepth = 40.mm if not $v_LDepth		##setable thickness of the leaf
		@s_LMaterial = "Door-Leaf"			#default colour for the leaf
		@s_DamdH_W1 = 830.mm				#default width of the leaf for Door & Half Size 1
		@s_DamdH_W2 = 930.mm				#default width of the leaf for Door & Half Size 2
		@s_DamdH_W3 = 1030.mm				#default width of the leaf for Door & Half Size 3
		@s_DamdH_W4 = 1130.mm				#default width of the leaf for Door & Half Size 4
		@s_LGrpName = "DM Leaf"
		$s_LOffset = "Flush" if not $s_LOffset		#setable position for leaf
		
		#Kicker Defaults
		@v_KFromEdge = 25.mm				#gap between kicker and the leaf edge
		@v_KHeight = 150.mm				#height of the kicker
		@v_KThick = 5.mm				#thickness of the plate
		@s_KMaterial = "Door-Fittings"			#default colour for the kicker
		$s_KInOn = "NO" if not $s_KInOn			##setable kicker on or off
		$s_KOutOn = "YES" if not $s_KOutOn		##setable kicker on or off
		
		#Name Plate Defaults
		@v_NWidth = 250.mm				#default nameplate width
		@v_NHeight = 75.mm				#default nameplate height
		@v_NFromTop = 300.mm				#default vertical posion from top of leaf
		@v_NThick = 5.mm				#default thickness of plate
		@s_NMaterial = "Door-Nameplate"			#default colour of plate
		$s_NInOn = "NO" if not $s_NInOn			##setable nameplate on or off
		$s_NOutOn = "NO" if not $s_NOutOn		##setable nameplate on or off
		
		#Handle Defaults
		$s_HInStyle = "Handle" if not $s_HInStyle	##setable handle style
		$s_HOutStyle = "Handle" if not $s_HOutStyle	##setable handle style
		@s_HMaterial = "Door-Fittings"			#default material for handle
		@v_HShaft1D = 50.mm				#default dia of collar/coverplate
		@v_HShaft1L = 10.mm				#default lenght/depth of collar
		@v_HShaft2D = 20.mm				#default dia of handle shaft
		@v_HShaft2L = 35.mm				#default lenght/depth of handle shaft
		@v_HHeight = 20.mm				#default height of the handle itsself
		@v_HLength = 150.mm				#default lenght of the handle itsself
		@v_HThick = 10.mm				#default thickness of the handle itsself
		@v_HFromEdge = 80.mm				#default distance of handle centre from edge of leaf
		@v_HFromG = 1000.mm				#default height from ground of handel
		@v_HPplateH = 350.mm				#default pushplate height
		@v_HPplateW = 85.mm				#default pushplate width
		@v_HPplateT = 5.mm				#default pushplate thickness
		@v_HLBarL = 1000.mm				#default longbar height
		@v_HLBarD = 35.mm				#default longbar dia
		@v_HPanicD = 25.mm				#default panic par dia
		@v_HPanicT = 10.mm				#default panic bar bracket thickness
		@v_HPanicH = 75.mm				#default panic bar bracket height
		@v_HPanicO = 50.mm				#default panic bar bracket depth(offset) from leaf
		@v_HSegs = 12					#default secments in curved/round handel parts
		
		#Panel Defaults
		$s_PanelStyle = "None" if not $s_PanelStyle	##setable panel style
		@s_PanelMaterial = "Door-Glass"			#default material for panel
		@v_PanelFromTop = 100.mm			#position from top of leaf
		@v_PanelWidth = 175.mm				#width of panel
		@v_PanelInset = 10.mm				#depth and width of inset
		#bottom of visionpanel is bottom of pushplate
		@v_PortH_D = 300.mm				#Porthole dia
		@v_PortH_FromG = 1700.mm			#center height from ground
		
		
		#Swing Defaults
		$s_SwingStyle = "Single Swing" if not $s_SwingStyle				#setable switch for the swing arc
		@v_SwingFromG = 1.mm								#default height that swing arc is drawn
		@s_SwingGrpName = "DM Swing Arc"
		@v_SwingSegs = 10								#default segments in arc
		
		$s_UseMaterials = "YES" if not $s_UseMaterials					#setabe default for using materials
		
		d_dstyles = ["Single"'|'"Double"'|'"Door & a Half 830mm"'|'"Door & a Half 930mm"'|'"Door & a Half 1030mm"'|'"Door & a Half 1130mm"]
		d_fstyles = ["Simple"'|'"Rebated"'|'"Rebated + Architrave"]						#setable list for the frame style
		d_loffset = ["Flush"'|'"Centred"]
		d_hstyles = ["None"'|'"Handle"'|'"Push Plate"'|'"Long Bar"'|'"Panic Bolt"]	#setable list for the handel style
		d_panelstyles = ["None"'|'"VP Centered"'|'"VP Offset"'|'"1x1 Glass"'|'"1x1 Solid"'|'"1x2 Glass"'|'"1x2 Solid"'|'"Port Hole"]	#setable list for the vision panel
		d_SwingStyle = ["None"'|'"Single Swing"'|'"Double Swing"]
		
		d_truefalse = ["YES"'|'"NO"]							#yes or no for use in the dialog
	
	#-----------------------------------------------------------------------------------------------
		#Prompt for dims
		#Create arrays for prompts
		prompts = [	"layer Root",			#1
				"Door type",			#1a
				"Opening Width",		#2
				"Opening Height",		#3
				"Frame Depth",			#4
				"Frame Width",			#5
				"Frame Profile",		#6
				"Leaf Thickness",		#7
				"Leaf Offset",			#7a
				"Panel Type",			#8
				"Kicker Outward",		#9
				"Kicker Inward",		#10
				"Nameplate Outward",		#11
				"Nameplate Inward",		#12
				"Handle Outward",		#13
				"Handle Inward",		#14
				"Swing Arc Style",		#15
				"Create/Use Default Materials "	#16
									]
		values = [	$s_LayerRoot,			#1
				$s_DoorType,			#1a
				$v_FWidth,			#2
				$v_FHeight,			#3
				$v_FDepth,			#4
				$v_FThick,			#5
				$s_FStyle,			#6
				$v_LDepth,			#7
				$s_LOffset,			#7a
				$s_PanelStyle,			#8
				$s_KOutOn,			#9
				$s_KInOn,			#10
				$s_NOutOn,			#11
				$s_NInOn,			#12
				$s_HOutStyle,			#13
				$s_HInStyle,			#14	
				$s_SwingStyle,			#15
				$s_UseMaterials			#16
						]
		enums = [	'',				#1
				d_dstyles,			#1a
				'',				#2
				'',				#3
				'',				#4
				'',				#5
				d_fstyles,			#6
				'',				#7
				d_loffset,			#7a	
				d_panelstyles,			#8
				d_truefalse,			#9
				d_truefalse,			#10
				d_truefalse,			#11
				d_truefalse,			#12
				d_hstyles,			#13
				d_hstyles,			#14
				d_SwingStyle,			#15
				d_truefalse			#16
						]
		#Now display the inputbOx (from sketchup.rb)
		results = inputbox prompts, values, enums, "Door Settings"
	
		return if not results # This means that the user canceled the operation
	
				$s_LayerRoot,			#1
				$s_DoorType,			#1a
				$v_FWidth,			#2
				$v_FHeight,			#3
				$v_FDepth,			#4
				$v_FThick,			#5
				$s_FStyle,			#6
				$v_LDepth,			#7
				$s_LOffset,			#7a
				$s_PanelStyle,			#8
				$s_KOutOn,			#9
				$s_KInOn,			#10
				$s_NOutOn,			#11
				$s_NInOn,			#12
				$s_HOutStyle,			#13
				$s_HInStyle,			#14
				$s_SwingStyle,			#15
				$s_UseMaterials=results		#16
						

	end #end initialize
	
	#-----------------------------------------------------------------------------------------------
	def onMouseMove(flags, x, y, view)    
		$a_FOrigintemp.pick view, x, y			# get a position in the model 
		if( $a_FOrigintemp.valid? )
			changed = $a_FOrigintemp != $vp
			$vp.copy! $a_FOrigintemp
			pos = $vp.position;
			$a_FOrigin=pos				#save position so it can be used in  onLButtonUp()
			$a_LOrigin = pos			
			msg = $vp.tooltip 		#start building tooltip message
			if( msg.length > 0 )
				msg << " "
			end
			msg << "Door Here: "
			msg << pos.x.to_s
			msg << ", "
			msg << pos.y.to_s
			msg << ", "
			msg << pos.z.to_s
			view.tooltip = msg		# show message as tooltip
			# check if display needs update
			if( changed and ($vp.display? or $displayed) )         
				view.invalidate		#make the view update  
			end
		end #end if	
	end #end onMouseMove
	
	#-----------------------------------------------------------------------------------------------
	def onLButtonUp(flags, x, y, view)		#called when left mouse button released
		dm_create_door
	end #end onLButtonUp
	
	#-----------------------------------------------------------------------------------------------
	def dm_create_door
			
		#get the current layer
		model = Sketchup.active_model
		layers = model.layers
		userlayer = model.active_layer
		model.commit_operation
	
	
		#set the rebate to zero or the leaf will be to big for the frame
		if($s_FStyle == "Simple") then  @v_FRebate=0 end
		
		#create the origin array for the leaf, Sketchup's base units are inches so
		#mm units have to be converted to inches to be added to the frame origins (thanks RickW)
		case $s_LOffset
		when "Centred"
			$a_LOrigin = [
					(($a_FOrigin.x+$v_FThick.to_inch-@v_FRebate.to_inch).to_mm).mm, 
					(($a_FOrigin.y+($v_FDepth.to_inch/2)-($v_LDepth.to_inch/2)).to_mm).mm,
					$a_FOrigin.z
					]
		when "Flush"
			$a_LOrigin = [
					(($a_FOrigin.x+$v_FThick.to_inch-@v_FRebate.to_inch).to_mm).mm, 
					(($a_FOrigin.y+$v_FDepth.to_inch-$v_LDepth.to_inch).to_mm).mm,
					$a_FOrigin.z
					]
		end #end case
		
		
		
		#set the size of the leaf
		case $s_DoorType
		when "Single"
			@v_LWidth = (($v_FWidth-$v_FThick-$v_FThick+@v_FRebate+@v_FRebate).to_mm).mm
		when "Double"
			@v_LWidth = ((($v_FWidth-$v_FThick-$v_FThick+@v_FRebate+@v_FRebate)/2).to_mm).mm
		when "Door & a Half 830mm"
			#Ok this is how I'm working it:
			#Say its a 1400mm opening, 50mm frame thickness and a 830mm main leaf
			#I set the leaf width to (1400-50-50)-830 = 470mm and make the leafset
			#Later in the script:
				#Mirror it without a copy
				#Then make a leafset of 830mm and do not mirror it
			@v_LWidth = ((($v_FWidth-$v_FThick-$v_FThick+@v_FRebate+@v_FRebate)-@s_DamdH_W1).to_mm).mm
		when "Door & a Half 930mm"
			@v_LWidth = ((($v_FWidth-$v_FThick-$v_FThick+@v_FRebate+@v_FRebate)-@s_DamdH_W2).to_mm).mm
		when "Door & a Half 1030mm"
			@v_LWidth = ((($v_FWidth-$v_FThick-$v_FThick+@v_FRebate+@v_FRebate)-@s_DamdH_W3).to_mm).mm
		when "Door & a Half 1130mm"
			@v_LWidth = ((($v_FWidth-$v_FThick-$v_FThick+@v_FRebate+@v_FRebate)-@s_DamdH_W4).to_mm).mm
		end #end case
		@v_LHeight = (($v_FHeight-$v_FThick+@v_FRebate).to_mm).mm

		#Go create the materials of the user wants them
		if($s_UseMaterials == "YES") then dm_add_paint end

		#Start the entire creation process
		@model = Sketchup.active_model
		
			#Create and set the master layer
			@s_LayerDoorSet2 = $s_LayerRoot+@s_LayerDoorSet	#set destination layer
			layers = @model.layers
			layers.add(@s_LayerDoorSet2)
			activelayer = @model.active_layer=layers[@s_LayerDoorSet2]
			layer=@model.active_layer
			
			#create the master group for the door set
			@doorset_entities = @model.active_entities
			@doorset_group = @doorset_entities.add_group
			@doorset_entities = @doorset_group.entities
			@doorset_group.name = @s_DSGrpName
		
			#Create frame on the master group
			dm_create_frame
				case $s_DoorType
				when "Single", "Double"
					#create a group for all the leafs and swing arc
					@leafset_entities = @model.active_entities
					@leafset_group = @doorset_entities.add_group
					@leafset_entities = @leafset_group.entities
					@leafset_group.name = @s_LGrpName+"s"
					
					#Create leaf 00 degress open
					$s_LayerLeaf = $s_LayerRoot+@s_LayerLeaf00	#set destination layer
					$v_Langle = 0					#Set opening angle
					dm_create_leaf					#call routine
		
					#Create leaf 30 degress open
					$s_LayerLeaf = $s_LayerRoot+@s_LayerLeaf30
					$v_Langle = @v_Rad30
					dm_create_leaf
		
					#Create leaf 60 degress open
					$s_LayerLeaf = $s_LayerRoot+@s_LayerLeaf60
					$v_Langle = @v_Rad60
					dm_create_leaf
		
					#Create leaf 90 degress open
					$s_LayerLeaf = $s_LayerRoot+@s_LayerLeaf90
					$v_Langle = @v_Rad90
					dm_create_leaf
		
					#Create swing Arc
					if($s_SwingStyle != "None")
						@s_LayerSwing2 = $s_LayerRoot+@s_LayerSwing	#set destination layer
						dm_create_swing				#call routine
					end
					
					#now we have our leafset group we need to make a copy and mirror(scale -1) it if its a double door
					if($s_DoorType == "Double")
						#Set the master layer
						@s_LayerDoorSet2 = $s_LayerRoot+@s_LayerDoorSet	#set destination layer
						layers = @model.layers
						activelayer = @model.active_layer=layers[@s_LayerDoorSet2]
						layer=@model.active_layer
				
						@leafset2_group=@leafset_group.copy
						@leafset2_group.name = @s_LGrpName+"s"
						mpoint = Geom::Point3d.new $a_FOrigin.x+($v_FWidth/2), $a_FOrigin.y, $a_FOrigin.z				
						tr=Geom::Transformation.scaling mpoint,-1,1,1
						@leafset2_group.transform!(tr)
					end #end if
				
				when "Door & a Half 830mm", "Door & a Half 930mm", "Door & a Half 1030mm", "Door & a Half 1130mm"
				#first we have to make the smaller leafset (the size has already been set above)
					
					#create a group for all the leafs and swing arc
					@leafset_entities = @model.active_entities
					@leafset_group = @doorset_entities.add_group
					@leafset_entities = @leafset_group.entities
					@leafset_group.name = @s_LGrpName+"s"
					
					#Create leaf 00 degress open
					$s_LayerLeaf = $s_LayerRoot+@s_LayerLeaf00	#set destination layer
					$v_Langle = 0					#Set opening angle
					dm_create_leaf					#call routine
		
					#Create leaf 30 degress open
					$s_LayerLeaf = $s_LayerRoot+@s_LayerLeaf30
					$v_Langle = @v_Rad30
					dm_create_leaf
		
					#Create leaf 60 degress open
					$s_LayerLeaf = $s_LayerRoot+@s_LayerLeaf60
					$v_Langle = @v_Rad60
					dm_create_leaf
		
					#Create leaf 90 degress open
					$s_LayerLeaf = $s_LayerRoot+@s_LayerLeaf90
					$v_Langle = @v_Rad90
					dm_create_leaf
		
					#Create swing Arc
					if($s_SwingStyle != "None")
						@s_LayerSwing2 = $s_LayerRoot+@s_LayerSwing	#set destination layer
						dm_create_swing					#call routine
					end

					#Set the master layer
					@s_LayerDoorSet2 = $s_LayerRoot+@s_LayerDoorSet	#set destination layer
					layers = @model.layers
					activelayer = @model.active_layer=layers[@s_LayerDoorSet2]
					layer=@model.active_layer

					#mirror (scale -1) the group about the midpoint of the frame
					@leafset_group.name = @s_LGrpName+"s"
					mpoint = Geom::Point3d.new $a_FOrigin.x+($v_FWidth/2), $a_FOrigin.y, $a_FOrigin.z				
					tr=Geom::Transformation.scaling mpoint,-1,1,1
					@leafset_group.transform!(tr)
					
					
					#now we can make the larger leafset
					#create a group for all the leafs and swing arc
					@leafset_entities = @model.active_entities
					@leafset_group = @doorset_entities.add_group
					@leafset_entities = @leafset_group.entities
					@leafset_group.name = @s_LGrpName+"s"
					
					#set the width of the master leaf
					case $s_DoorType
					when "Door & a Half 830mm"
						@v_LWidth = @s_DamdH_W1
					when "Door & a Half 930mm"
						@v_LWidth = @s_DamdH_W2
					when "Door & a Half 1030mm"
						@v_LWidth = @s_DamdH_W3
					when "Door & a Half 1130mm"
						@v_LWidth = @s_DamdH_W4
					end #end case
					
					
					#Create leaf 00 degress open
					$s_LayerLeaf = $s_LayerRoot+@s_LayerLeaf00	#set destination layer
					$v_Langle = 0					#Set opening angle
					dm_create_leaf					#call routine
		
					#Create leaf 30 degress open
					$s_LayerLeaf = $s_LayerRoot+@s_LayerLeaf30
					$v_Langle = @v_Rad30
					dm_create_leaf
		
					#Create leaf 60 degress open
					$s_LayerLeaf = $s_LayerRoot+@s_LayerLeaf60
					$v_Langle = @v_Rad60
					dm_create_leaf
		
					#Create leaf 90 degress open
					$s_LayerLeaf = $s_LayerRoot+@s_LayerLeaf90
					$v_Langle = @v_Rad90
					dm_create_leaf
		
					#Create swing Arc
					if($s_SwingStyle != "None")
						@s_LayerSwing2 = $s_LayerRoot+@s_LayerSwing	#set destination layer
						dm_create_swing					#call routine
					end
				
				end #end case
		
		#End the entire creation process
		@model.commit_operation
		
		#reset the layer back to the users layer
		layers = model.layers
		activelayer = model.active_layer= userlayer
		layer=model.active_layer
		model.commit_operation
		
	end	# end of dm_create_door
#-----------------------------------------------------------------------------------------------



	#-----------------------------------------------------------------------------------------------
	#Routines
	#-----------------------------------------------------------------------------------------------
	def dm_create_frame

		@model.start_operation("Create Door Frame")

		#Create and set layer
		layers = @model.layers
		layers.add(@s_LayerDoorSet2)
		activelayer = @model.active_layer=layers[@s_LayerDoorSet2]
		layer=@model.active_layer

		@frame_entities = @model.active_entities
	
		@frame_group = @doorset_entities.add_group
		@frame_entities = @frame_group.entities
		@frame_group.name = @s_FGrpName
		
		#create the path for the frame profile to follow
		pts = Array.new(4) { $a_FOrigin.clone }
		pts[1].z += $v_FHeight				#x		y		+FHeight
		pts[2].x += $v_FWidth				#+FWidth	y		z
		pts[2].z += $v_FHeight				#x		y		+FHeight
		pts[3].x += $v_FWidth				#+FWidth	y		z
		path = @frame_entities.add_edges(pts)
		
		#create the profile
		case $s_FStyle
		when "Simple"
			pts = Array.new(4) { $a_FOrigin.clone }
			pts[1].y += $v_FDepth			#x		+FDepth		z
			pts[2].x += $v_FThick			#+FThick	y		z
			pts[2].y += $v_FDepth			#x		+FDepth		z
			pts[3].x += $v_FThick			#+FThick	y		z
			
		when "Rebated"	
			pts = Array.new(6) { $a_FOrigin.clone }
			pts[1].y += $v_FDepth			#x		+FDepth		z
			pts[2].y += $v_FDepth			#x		+FDepth		z
			pts[2].x += $v_FThick-@v_FRebate	#+FThick+FReb	y		z
			pts[3].x += $v_FThick-@v_FRebate	#+FThick+FReb	y		z
			pts[3].y = $a_LOrigin.y			#x		=LOrigin	z
			pts[4].x += $v_FThick			#+FThick	y		z
			pts[4].y = $a_LOrigin.y			#x		=LOrigin	z
			pts[5].x += $v_FThick			#+FThick	y		z
		when "Rebated + Architrave"
			pts = Array.new(14) { $a_FOrigin.clone }
			#pts[1].x
			pts[1].y += $v_FDepth
			pts[2].x += -($v_FThick/2)
			pts[2].y += $v_FDepth
			pts[3].x += -($v_FThick/2)
			pts[3].y += $v_FDepth+@v_FRebate
			pts[4].x += ($v_FThick/2)
			pts[4].y += $v_FDepth+@v_FRebate
			pts[5].x += ($v_FThick/2)
			pts[5].y += $v_FDepth
			pts[6].x += $v_FThick-@v_FRebate
			pts[6].y += $v_FDepth
			pts[7].x += $v_FThick-@v_FRebate
			pts[7].y = $a_LOrigin.y	
			pts[8].x += $v_FThick
			pts[8].y = $a_LOrigin.y	
			pts[9].x += $v_FThick
			#pts[9].y
			pts[10].x += ($v_FThick/2)
			#pts[10].y
			pts[11].x += ($v_FThick/2)
			pts[11].y += -@v_FRebate
			pts[12].x += -($v_FThick/2)
			pts[12].y += -@v_FRebate
			pts[13].x += -($v_FThick/2)
			#pts[13].y

		
		end #end case
		#create face from points
		profile = @frame_entities.add_face(pts)
		#Paint
		if($s_UseMaterials == "YES") then profile.material = @s_FMaterial end
		#pull the profile around the path to make the frame
		profile.followme(path)
			    
	end	# end of dm_create_frame
	
	#-----------------------------------------------------------------------------------------------
	def dm_create_leaf
	
		@model.start_operation("Create Door Leaf")
	
		#Create and set layer
		layers = @model.layers
		layers.add($s_LayerLeaf)
	  	activelayer = @model.active_layer=layers[$s_LayerLeaf]
		layer=@model.active_layer
	
		
		@leaf_entities = @model.active_entities
		
		@leaf_group = @leafset_entities.add_group
	        @leaf_entities = @leaf_group.entities
	        @leaf_group.name = @s_LGrpName
	        
		#Create The Leaf
		pts = Array.new(4) { $a_LOrigin.clone }
		pts[1].z += @v_LHeight				#x		y		+LHeight
		pts[2].x += @v_LWidth				#+LWidth	y		z
		pts[2].z += @v_LHeight				#x		y		+LHeight
		pts[3].x += @v_LWidth				#+LWidth	y		z
		#create face from points
		base = @leaf_entities.add_face(pts)
		#Paint
		if($s_UseMaterials == "YES") then base.material = @s_LMaterial end
		# Now we can do the pushpull
		base.pushpull($v_LDepth)
		
		#Create the vision panel
		#only create the panels if the leaf thickness is more than twice the inset depth or the leaf width is wider than the panel + 2x the from edge value
		if ($v_LDepth>(@v_PanelInset+@v_PanelInset)) and (@v_LWidth>(@v_PanelWidth+@v_PanelWidth))

			case $s_PanelStyle
			when "None"
			
			when "VP Centered"
				#Rebated inset on front of leaf
				pts = Array.new(4) { $a_LOrigin.clone }
				pts[0].x += (@v_LWidth/2)-(@v_PanelWidth/2)
				pts[0].z += @v_HFromG-(@v_HPplateH/2)
				pts[1].x += (@v_LWidth/2)-(@v_PanelWidth/2)
				pts[1].z += @v_LHeight-@v_PanelFromTop
				pts[2].x += (@v_LWidth/2)+(@v_PanelWidth/2)
				pts[2].z += @v_LHeight-@v_PanelFromTop
				pts[3].x += (@v_LWidth/2)+(@v_PanelWidth/2)
				pts[3].z += @v_HFromG-(@v_HPplateH/2)
				#create face from points
				base = @leaf_entities.add_face(pts)
				# Now we can do the pushpull
				base.pushpull(-@v_PanelInset)
				
				#Rebated inset on rear of leaf				
				pts = Array.new(4) { $a_LOrigin.clone }
				pts[0].x += (@v_LWidth/2)-(@v_PanelWidth/2)
				pts[0].y += $v_LDepth
				pts[0].z += @v_HFromG-(@v_HPplateH/2)
				pts[1].x += (@v_LWidth/2)-(@v_PanelWidth/2)
				pts[1].y += $v_LDepth
				pts[1].z += @v_LHeight-@v_PanelFromTop
				pts[2].x += (@v_LWidth/2)+(@v_PanelWidth/2)
				pts[2].y += $v_LDepth
				pts[2].z += @v_LHeight-@v_PanelFromTop
				pts[3].x += (@v_LWidth/2)+(@v_PanelWidth/2)
				pts[3].y += $v_LDepth
				pts[3].z += @v_HFromG-(@v_HPplateH/2)
				#create face from points
				base = @leaf_entities.add_face(pts)
				# Now we can do the pushpull
				base.pushpull(-@v_PanelInset)
				
				#hole through leaf
				pts = Array.new(4) { $a_LOrigin.clone }
				pts[0].x += (@v_LWidth/2)-(@v_PanelWidth/2)+@v_PanelInset
				pts[0].y += @v_PanelInset
				pts[0].z += @v_HFromG-(@v_HPplateH/2)+@v_PanelInset
				pts[1].x += (@v_LWidth/2)-(@v_PanelWidth/2)+@v_PanelInset
				pts[1].y += @v_PanelInset
				pts[1].z += @v_LHeight-@v_PanelFromTop-@v_PanelInset
				pts[2].x += (@v_LWidth/2)+(@v_PanelWidth/2)-@v_PanelInset
				pts[2].y += @v_PanelInset
				pts[2].z += @v_LHeight-@v_PanelFromTop-@v_PanelInset
				pts[3].x += (@v_LWidth/2)+(@v_PanelWidth/2)-@v_PanelInset
				pts[3].y += @v_PanelInset
				pts[3].z += @v_HFromG-(@v_HPplateH/2)+@v_PanelInset
				#create face from points
				base = @leaf_entities.add_face(pts)
				# Now we can do the pushpull
				base.pushpull(-($v_LDepth-@v_PanelInset-@v_PanelInset))
			
				#glass
				pts = Array.new(4) { $a_LOrigin.clone }
				pts[0].x += (@v_LWidth/2)-(@v_PanelWidth/2)+@v_PanelInset
				pts[0].y += ($v_LDepth/2)
				pts[0].z += @v_HFromG-(@v_HPplateH/2)+@v_PanelInset
				pts[1].x += (@v_LWidth/2)-(@v_PanelWidth/2)+@v_PanelInset
				pts[1].y += ($v_LDepth/2)
				pts[1].z += @v_LHeight-@v_PanelFromTop-@v_PanelInset
				pts[2].x += (@v_LWidth/2)+(@v_PanelWidth/2)-@v_PanelInset
				pts[2].y += ($v_LDepth/2)
				pts[2].z += @v_LHeight-@v_PanelFromTop-@v_PanelInset
				pts[3].x += (@v_LWidth/2)+(@v_PanelWidth/2)-@v_PanelInset
				pts[3].y += ($v_LDepth/2)
				pts[3].z += @v_HFromG-(@v_HPplateH/2)+@v_PanelInset
				#create face from points
				base = @leaf_entities.add_face(pts)
				#Paint
				if($s_UseMaterials == "YES") then base.material = @s_PanelMaterial end
				
				
			when "VP Offset"
				#Rebated inset on front of leaf
				pts = Array.new(4) { $a_LOrigin.clone }
				pts[0].x += @v_LWidth-@v_HFromEdge-@v_HPplateW-(@v_HFromEdge/2)-@v_PanelWidth
				pts[0].z += @v_HFromG-(@v_HPplateH/2)
				pts[1].x += @v_LWidth-@v_HFromEdge-@v_HPplateW-(@v_HFromEdge/2)-@v_PanelWidth
				pts[1].z += @v_LHeight-@v_PanelFromTop
				pts[2].x += @v_LWidth-@v_HFromEdge-@v_HPplateW-(@v_HFromEdge/2)
				pts[2].z += @v_LHeight-@v_PanelFromTop
				pts[3].x += @v_LWidth-@v_HFromEdge-@v_HPplateW-(@v_HFromEdge/2)
				pts[3].z += @v_HFromG-(@v_HPplateH/2)
				#create face from points
				base = @leaf_entities.add_face(pts)
				# Now we can do the pushpull
				base.pushpull(-@v_PanelInset)
				
				#Rebated inset on rear of leaf				
				pts = Array.new(4) { $a_LOrigin.clone }
				pts[0].x += @v_LWidth-@v_HFromEdge-@v_HPplateW-(@v_HFromEdge/2)-@v_PanelWidth
				pts[0].y += $v_LDepth
				pts[0].z += @v_HFromG-(@v_HPplateH/2)
				pts[1].x += @v_LWidth-@v_HFromEdge-@v_HPplateW-(@v_HFromEdge/2)-@v_PanelWidth
				pts[1].y += $v_LDepth
				pts[1].z += @v_LHeight-@v_PanelFromTop
				pts[2].x += @v_LWidth-@v_HFromEdge-@v_HPplateW-(@v_HFromEdge/2)
				pts[2].y += $v_LDepth
				pts[2].z += @v_LHeight-@v_PanelFromTop
				pts[3].x += @v_LWidth-@v_HFromEdge-@v_HPplateW-(@v_HFromEdge/2)
				pts[3].y += $v_LDepth
				pts[3].z += @v_HFromG-(@v_HPplateH/2)
				#create face from points
				base = @leaf_entities.add_face(pts)
				# Now we can do the pushpull
				base.pushpull(-@v_PanelInset)
				
				#hole through leaf
				pts = Array.new(4) { $a_LOrigin.clone }
				pts[0].x += @v_LWidth-@v_HFromEdge-@v_HPplateW-(@v_HFromEdge/2)-@v_PanelWidth+@v_PanelInset
				pts[0].y += @v_PanelInset
				pts[0].z += @v_HFromG-(@v_HPplateH/2)+@v_PanelInset
				pts[1].x += @v_LWidth-@v_HFromEdge-@v_HPplateW-(@v_HFromEdge/2)-@v_PanelWidth+@v_PanelInset
				pts[1].y += @v_PanelInset
				pts[1].z += @v_LHeight-@v_PanelFromTop-@v_PanelInset
				pts[2].x += @v_LWidth-@v_HFromEdge-@v_HPplateW-(@v_HFromEdge/2)-@v_PanelInset
				pts[2].y += @v_PanelInset
				pts[2].z += @v_LHeight-@v_PanelFromTop-@v_PanelInset
				pts[3].x += @v_LWidth-@v_HFromEdge-@v_HPplateW-(@v_HFromEdge/2)-@v_PanelInset
				pts[3].y += @v_PanelInset
				pts[3].z += @v_HFromG-(@v_HPplateH/2)+@v_PanelInset
				#create face from points
				base = @leaf_entities.add_face(pts)
				# Now we can do the pushpull
				base.pushpull(-($v_LDepth-@v_PanelInset-@v_PanelInset))
			
				#glass
				pts = Array.new(4) { $a_LOrigin.clone }
				pts[0].x += @v_LWidth-@v_HFromEdge-@v_HPplateW-(@v_HFromEdge/2)-@v_PanelWidth+@v_PanelInset
				pts[0].y += ($v_LDepth/2)
				pts[0].z += @v_HFromG-(@v_HPplateH/2)+@v_PanelInset
				pts[1].x += @v_LWidth-@v_HFromEdge-@v_HPplateW-(@v_HFromEdge/2)-@v_PanelWidth+@v_PanelInset
				pts[1].y += ($v_LDepth/2)
				pts[1].z += @v_LHeight-@v_PanelFromTop-@v_PanelInset
				pts[2].x += @v_LWidth-@v_HFromEdge-@v_HPplateW-(@v_HFromEdge/2)-@v_PanelInset
				pts[2].y += ($v_LDepth/2)
				pts[2].z += @v_LHeight-@v_PanelFromTop-@v_PanelInset
				pts[3].x += @v_LWidth-@v_HFromEdge-@v_HPplateW-(@v_HFromEdge/2)-@v_PanelInset
				pts[3].y += ($v_LDepth/2)
				pts[3].z += @v_HFromG-(@v_HPplateH/2)+@v_PanelInset
				#create face from points
				base = @leaf_entities.add_face(pts)
				#Paint
				if($s_UseMaterials == "YES") then base.material = @s_PanelMaterial end
				
			#if the user wants a 1x1 panel either solid or glass then...
			when "1x1 Glass", "1x1 Solid"
				#Rebated inset on front of leaf
				pts = Array.new(4) { $a_LOrigin.clone }
				pts[0].x += @v_HFromEdge+@v_HFromEdge
				pts[0].z += @v_KFromEdge+@v_KHeight+@v_KFromEdge
				pts[1].x += @v_HFromEdge+@v_HFromEdge
				pts[1].z += @v_LHeight-@v_PanelFromTop
				pts[2].x += @v_LWidth-+@v_HFromEdge-@v_HPplateW-@v_HFromEdge
				pts[2].z += @v_LHeight-@v_PanelFromTop
				pts[3].x += @v_LWidth-+@v_HFromEdge-@v_HPplateW-@v_HFromEdge
				pts[3].z += @v_KFromEdge+@v_KHeight+@v_KFromEdge
				#create face from points
				base = @leaf_entities.add_face(pts)
				# Now we can do the pushpull
				base.pushpull(-@v_PanelInset)
				
				#Rebated inset on rear of leaf
				pts = Array.new(4) { $a_LOrigin.clone }
				pts[0].x += @v_HFromEdge+@v_HFromEdge
				pts[0].y += $v_LDepth
				pts[0].z += @v_KFromEdge+@v_KHeight+@v_KFromEdge
				pts[1].x += @v_HFromEdge+@v_HFromEdge
				pts[1].y += $v_LDepth
				pts[1].z += @v_LHeight-@v_PanelFromTop
				pts[2].x += @v_LWidth-+@v_HFromEdge-@v_HPplateW-@v_HFromEdge
				pts[2].y += $v_LDepth
				pts[2].z += @v_LHeight-@v_PanelFromTop
				pts[3].x += @v_LWidth-+@v_HFromEdge-@v_HPplateW-@v_HFromEdge
				pts[3].y += $v_LDepth
				pts[3].z += @v_KFromEdge+@v_KHeight+@v_KFromEdge
				#create face from points
				base = @leaf_entities.add_face(pts)
				# Now we can do the pushpull
				base.pushpull(-@v_PanelInset)
				
				#if the 1x1 panel is glass then go ahead and punch the hole and fill it with glass
				if($s_PanelStyle == "1x1 Glass")
					#hole through leaf
					pts = Array.new(4) { $a_LOrigin.clone }
					pts[0].x += @v_HFromEdge+@v_HFromEdge+@v_PanelInset
					pts[0].y += @v_PanelInset
					pts[0].z += @v_KFromEdge+@v_KHeight+@v_KFromEdge+@v_PanelInset
					pts[1].x += @v_HFromEdge+@v_HFromEdge+@v_PanelInset
					pts[1].y += @v_PanelInset
					pts[1].z += @v_LHeight-@v_PanelFromTop-@v_PanelInset
					pts[2].x += @v_LWidth-+@v_HFromEdge-@v_HPplateW-@v_HFromEdge-@v_PanelInset
					pts[2].y += @v_PanelInset
					pts[2].z += @v_LHeight-@v_PanelFromTop-@v_PanelInset
					pts[3].x += @v_LWidth-+@v_HFromEdge-@v_HPplateW-@v_HFromEdge-@v_PanelInset
					pts[3].y += @v_PanelInset
					pts[3].z += @v_KFromEdge+@v_KHeight+@v_KFromEdge+@v_PanelInset
					#create face from points
					base = @leaf_entities.add_face(pts)
					# Now we can do the pushpull
					base.pushpull(-($v_LDepth-@v_PanelInset-@v_PanelInset))
					
					#glass
					pts = Array.new(4) { $a_LOrigin.clone }
					pts[0].x += @v_HFromEdge+@v_HFromEdge+@v_PanelInset
					pts[0].y += ($v_LDepth/2)
					pts[0].z += @v_KFromEdge+@v_KHeight+@v_KFromEdge+@v_PanelInset
					pts[1].x += @v_HFromEdge+@v_HFromEdge+@v_PanelInset
					pts[1].y += ($v_LDepth/2)
					pts[1].z += @v_LHeight-@v_PanelFromTop-@v_PanelInset
					pts[2].x += @v_LWidth-+@v_HFromEdge-@v_HPplateW-@v_HFromEdge-@v_PanelInset
					pts[2].y += ($v_LDepth/2)
					pts[2].z += @v_LHeight-@v_PanelFromTop-@v_PanelInset
					pts[3].x += @v_LWidth-+@v_HFromEdge-@v_HPplateW-@v_HFromEdge-@v_PanelInset
					pts[3].y += ($v_LDepth/2)
					pts[3].z += @v_KFromEdge+@v_KHeight+@v_KFromEdge+@v_PanelInset
					#create face from points
					base = @leaf_entities.add_face(pts)
					#Paint
					if($s_UseMaterials == "YES") then base.material = @s_PanelMaterial end
				end #end if
			
			#if the user wants a 1x2 panel either solid or glass then...
			when "1x2 Glass", "1x2 Solid"
				#only create the 2 panels if the leaf height is (a bit) taller than the handle height
				if ((@v_HFromG+@v_HFromEdge+@v_HFromEdge) < @v_LHeight)
				#Lower Panel
					#Rebated inset on front of leaf
					pts = Array.new(4) { $a_LOrigin.clone }
					pts[0].x += @v_HFromEdge+@v_HFromEdge
					pts[0].z += @v_KFromEdge+@v_KHeight+@v_KFromEdge
					pts[1].x += @v_HFromEdge+@v_HFromEdge
					pts[1].z += @v_HFromG-@v_HFromEdge
					pts[2].x += @v_LWidth-+@v_HFromEdge-@v_HPplateW-@v_HFromEdge
					pts[2].z += @v_HFromG-@v_HFromEdge
					pts[3].x += @v_LWidth-+@v_HFromEdge-@v_HPplateW-@v_HFromEdge
					pts[3].z += @v_KFromEdge+@v_KHeight+@v_KFromEdge
					#create face from points
					base = @leaf_entities.add_face(pts)
					# Now we can do the pushpull
					base.pushpull(-@v_PanelInset)
					
					#Rebated inset on rear of leaf
					pts = Array.new(4) { $a_LOrigin.clone }
					pts[0].x += @v_HFromEdge+@v_HFromEdge
					pts[0].y += $v_LDepth
					pts[0].z += @v_KFromEdge+@v_KHeight+@v_KFromEdge
					pts[1].x += @v_HFromEdge+@v_HFromEdge
					pts[1].y += $v_LDepth
					pts[1].z += @v_HFromG-@v_HFromEdge
					pts[2].x += @v_LWidth-+@v_HFromEdge-@v_HPplateW-@v_HFromEdge
					pts[2].y += $v_LDepth
					pts[2].z += @v_HFromG-@v_HFromEdge
					pts[3].x += @v_LWidth-+@v_HFromEdge-@v_HPplateW-@v_HFromEdge
					pts[3].y += $v_LDepth
					pts[3].z += @v_KFromEdge+@v_KHeight+@v_KFromEdge
					#create face from points
					base = @leaf_entities.add_face(pts)
					# Now we can do the pushpull
					base.pushpull(-@v_PanelInset)
					
					#if the 1x2 panel is glass then go ahead and punch the hole and fill it with glass
					if($s_PanelStyle == "1x2 Glass")
						#hole through leaf
						pts = Array.new(4) { $a_LOrigin.clone }
						pts[0].x += @v_HFromEdge+@v_HFromEdge+@v_PanelInset
						pts[0].y += @v_PanelInset
						pts[0].z += @v_KFromEdge+@v_KHeight+@v_KFromEdge+@v_PanelInset
						pts[1].x += @v_HFromEdge+@v_HFromEdge+@v_PanelInset
						pts[1].y += @v_PanelInset
						pts[1].z += @v_HFromG-@v_HFromEdge-@v_PanelInset
						pts[2].x += @v_LWidth-+@v_HFromEdge-@v_HPplateW-@v_HFromEdge-@v_PanelInset
						pts[2].y += @v_PanelInset
						pts[2].z += @v_HFromG-@v_HFromEdge-@v_PanelInset
						pts[3].x += @v_LWidth-+@v_HFromEdge-@v_HPplateW-@v_HFromEdge-@v_PanelInset
						pts[3].y += @v_PanelInset
						pts[3].z += @v_KFromEdge+@v_KHeight+@v_KFromEdge+@v_PanelInset
						#create face from points
						base = @leaf_entities.add_face(pts)
						# Now we can do the pushpull
						base.pushpull(-($v_LDepth-@v_PanelInset-@v_PanelInset))
						
						#glass
						pts = Array.new(4) { $a_LOrigin.clone }
						pts[0].x += @v_HFromEdge+@v_HFromEdge+@v_PanelInset
						pts[0].y += ($v_LDepth/2)
						pts[0].z += @v_KFromEdge+@v_KHeight+@v_KFromEdge+@v_PanelInset
						pts[1].x += @v_HFromEdge+@v_HFromEdge+@v_PanelInset
						pts[1].y += ($v_LDepth/2)
						pts[1].z += @v_HFromG-@v_HFromEdge-@v_PanelInset
						pts[2].x += @v_LWidth-+@v_HFromEdge-@v_HPplateW-@v_HFromEdge-@v_PanelInset
						pts[2].y += ($v_LDepth/2)
						pts[2].z += @v_HFromG-@v_HFromEdge-@v_PanelInset
						pts[3].x += @v_LWidth-+@v_HFromEdge-@v_HPplateW-@v_HFromEdge-@v_PanelInset
						pts[3].y += ($v_LDepth/2)
						pts[3].z += @v_KFromEdge+@v_KHeight+@v_KFromEdge+@v_PanelInset
						#create face from points
						base = @leaf_entities.add_face(pts)
						#Paint
						if($s_UseMaterials == "YES") then base.material = @s_PanelMaterial end
					end #end if

				#Upper Panel
					#Rebated inset on front of leaf
					pts = Array.new(4) { $a_LOrigin.clone }
					pts[0].x += @v_HFromEdge+@v_HFromEdge
					pts[0].z += @v_HFromG+@v_HFromEdge
					pts[1].x += @v_HFromEdge+@v_HFromEdge
					pts[1].z += @v_LHeight-@v_PanelFromTop
					pts[2].x += @v_LWidth-+@v_HFromEdge-@v_HPplateW-@v_HFromEdge
					pts[2].z += @v_LHeight-@v_PanelFromTop
					pts[3].x += @v_LWidth-+@v_HFromEdge-@v_HPplateW-@v_HFromEdge
					pts[3].z += @v_HFromG+@v_HFromEdge
					#create face from points
					base = @leaf_entities.add_face(pts)
					# Now we can do the pushpull
					base.pushpull(-@v_PanelInset)
					
					#Rebated inset on rear of leaf
					pts = Array.new(4) { $a_LOrigin.clone }
					pts[0].x += @v_HFromEdge+@v_HFromEdge
					pts[0].y += $v_LDepth
					pts[0].z += @v_HFromG+@v_HFromEdge
					pts[1].x += @v_HFromEdge+@v_HFromEdge
					pts[1].y += $v_LDepth
					pts[1].z += @v_LHeight-@v_PanelFromTop
					pts[2].x += @v_LWidth-+@v_HFromEdge-@v_HPplateW-@v_HFromEdge
					pts[2].y += $v_LDepth
					pts[2].z += @v_LHeight-@v_PanelFromTop
					pts[3].x += @v_LWidth-+@v_HFromEdge-@v_HPplateW-@v_HFromEdge
					pts[3].y += $v_LDepth
					pts[3].z += @v_HFromG+@v_HFromEdge
					#create face from points
					base = @leaf_entities.add_face(pts)
					# Now we can do the pushpull
					base.pushpull(-@v_PanelInset)
					
					#if the 1x2 panel is glass then go ahead and punch the hole and fill it with glass
					if($s_PanelStyle == "1x2 Glass")
						#hole through leaf
						pts = Array.new(4) { $a_LOrigin.clone }
						pts[0].x += @v_HFromEdge+@v_HFromEdge+@v_PanelInset
						pts[0].y += @v_PanelInset
						pts[0].z += @v_HFromG+@v_HFromEdge+@v_PanelInset
						pts[1].x += @v_HFromEdge+@v_HFromEdge+@v_PanelInset
						pts[1].y += @v_PanelInset
						pts[1].z += @v_LHeight-@v_PanelFromTop-@v_PanelInset
						pts[2].x += @v_LWidth-+@v_HFromEdge-@v_HPplateW-@v_HFromEdge-@v_PanelInset
						pts[2].y += @v_PanelInset
						pts[2].z += @v_LHeight-@v_PanelFromTop-@v_PanelInset
						pts[3].x += @v_LWidth-+@v_HFromEdge-@v_HPplateW-@v_HFromEdge-@v_PanelInset
						pts[3].y += @v_PanelInset
						pts[3].z += @v_HFromG+@v_HFromEdge+@v_PanelInset
						#create face from points
						base = @leaf_entities.add_face(pts)
						# Now we can do the pushpull
						base.pushpull(-($v_LDepth-@v_PanelInset-@v_PanelInset))
						
						#glass
						pts = Array.new(4) { $a_LOrigin.clone }
						pts[0].x += @v_HFromEdge+@v_HFromEdge+@v_PanelInset
						pts[0].y += ($v_LDepth/2)
						pts[0].z += @v_HFromG+@v_HFromEdge+@v_PanelInset
						pts[1].x += @v_HFromEdge+@v_HFromEdge+@v_PanelInset
						pts[1].y += ($v_LDepth/2)
						pts[1].z += @v_LHeight-@v_PanelFromTop-@v_PanelInset
						pts[2].x += @v_LWidth-+@v_HFromEdge-@v_HPplateW-@v_HFromEdge-@v_PanelInset
						pts[2].y += ($v_LDepth/2)
						pts[2].z += @v_LHeight-@v_PanelFromTop-@v_PanelInset
						pts[3].x += @v_LWidth-+@v_HFromEdge-@v_HPplateW-@v_HFromEdge-@v_PanelInset
						pts[3].y += ($v_LDepth/2)
						pts[3].z += @v_HFromG+@v_HFromEdge+@v_PanelInset
						#create face from points
						base = @leaf_entities.add_face(pts)
						#Paint
						if($s_UseMaterials == "YES") then base.material = @s_PanelMaterial end
					end #end if
				end #end if
			when "Port Hole"
				#only create the port hole id the leaf is wide enough
				if (@v_LWidth > (@v_PortH_D+(@v_PanelInset*4)+(@v_HFromEdge*4)))
					#create the frame on the 1st side of the leaf
					if @v_PortH_FromG+(@v_PortH_D/2)+(@v_PanelInset*2)+(@v_HFromEdge*2) < @v_LHeight
						pt1 = [$a_LOrigin.x+(@v_LWidth/2), $a_LOrigin.y, $a_LOrigin.z+@v_PortH_FromG]
					else
						pt1 = [$a_LOrigin.x+(@v_LWidth/2), $a_LOrigin.y, $a_LOrigin.z+@v_LHeight-(@v_HFromEdge*2)-(@v_PanelInset*2)-(@v_PortH_D/2)]
					end #end if
					circ = @leaf_entities.add_circle(pt1, Y_AXIS, (@v_PortH_D/2)+(@v_PanelInset*2), @v_HSegs*2)
					if($s_UseMaterials == "YES") then @leaf_entities[-1].material = @s_HMaterial end
					@leaf_entities[-1].pushpull(@v_PanelInset)
	
					#create the frame on the 2nd side of the leaf
					if @v_PortH_FromG+(@v_PortH_D/2)+(@v_PanelInset*2)+(@v_HFromEdge*2) < @v_LHeight
						pt1 = [$a_LOrigin.x+(@v_LWidth/2), $a_LOrigin.y+$v_LDepth, $a_LOrigin.z+@v_PortH_FromG]
					else
						pt1 = [$a_LOrigin.x+(@v_LWidth/2), $a_LOrigin.y+$v_LDepth, $a_LOrigin.z+@v_LHeight-(@v_HFromEdge*2)-(@v_PanelInset*2)-(@v_PortH_D/2)]
					end #end if
					circ = @leaf_entities.add_circle(pt1, Y_AXIS, (@v_PortH_D/2)+(@v_PanelInset*2), @v_HSegs*2)
					if($s_UseMaterials == "YES") then @leaf_entities[-1].material = @s_HMaterial end
					@leaf_entities[-1].pushpull(@v_PanelInset)
	
					#create the hole through the leaf
					if @v_PortH_FromG+(@v_PortH_D/2)+(@v_PanelInset*2)+(@v_HFromEdge*2) < @v_LHeight
						pt1 = [$a_LOrigin.x+(@v_LWidth/2), $a_LOrigin.y-@v_PanelInset, $a_LOrigin.z+@v_PortH_FromG]
					else
						pt1 = [$a_LOrigin.x+(@v_LWidth/2), $a_LOrigin.y-@v_PanelInset, $a_LOrigin.z+@v_LHeight-(@v_HFromEdge*2)-(@v_PanelInset*2)-(@v_PortH_D/2)]
					end #end if
					circ = @leaf_entities.add_circle(pt1, Y_AXIS, (@v_PortH_D/2), @v_HSegs*2)
					if($s_UseMaterials == "YES") then @leaf_entities[-1].material = @s_HMaterial end
					@leaf_entities[-1].pushpull(-(@v_PanelInset+$v_LDepth+@v_PanelInset))
	
					#create the glass to fill the hole
					if @v_PortH_FromG+(@v_PortH_D/2)+(@v_PanelInset*2)+(@v_HFromEdge*2) < @v_LHeight
						pt1 = [$a_LOrigin.x+(@v_LWidth/2), $a_LOrigin.y+($v_LDepth/2), $a_LOrigin.z+@v_PortH_FromG]
					else
						pt1 = [$a_LOrigin.x+(@v_LWidth/2), $a_LOrigin.y+($v_LDepth/2), $a_LOrigin.z+@v_LHeight-(@v_HFromEdge*2)-(@v_PanelInset*2)-(@v_PortH_D/2)]
					end #end if
					circ = @leaf_entities.add_circle(pt1, Y_AXIS, (@v_PortH_D/2), @v_HSegs*2)
					base = @leaf_entities.add_face(circ)
					if($s_UseMaterials == "YES") then base.material = @s_PanelMaterial end
				end #end if
			end #end case
		end #end if
		
		#Create the Kickers
		#if either the Outside or Inside kicker is set to on - make the outside kicker
		if($s_KOutOn == "YES") or ($s_KInOn =="YES")
		
			@kicker_entities = @model.active_entities
			@kicker_group = @leaf_entities.add_group
			@kicker_entities = @kicker_group.entities
			@kicker_group.name = "Kicker Out"
		
			#create the points
			pts = Array.new(4) { $a_LOrigin.clone }
			pts[0].x += @v_KFromEdge+@v_FRebate
			pts[0].z += @v_KFromEdge
			pts[1].x += @v_KFromEdge+@v_FRebate
			pts[1].z += @v_KFromEdge+@v_KHeight
			pts[2].x += @v_LWidth-@v_KFromEdge-@v_FRebate
			pts[2].z += @v_KFromEdge+@v_KHeight
			pts[3].x += @v_LWidth-@v_KFromEdge-@v_FRebate 
			pts[3].z += @v_KFromEdge
			#create face from points
			base = @kicker_entities.add_face(pts)
			base=base.reverse!
			#Paint
			if($s_UseMaterials == "YES") then base.material = @s_KMaterial end
			# Now we can do the pushpull
			base.pushpull(@v_KThick)

			#If it turns out that only the inside kicker is on then mirror the outside kicker to the inside
			if($s_KOutOn == "NO") and ($s_KInOn =="YES")
				@kicker_group.name = "Kicker In"
				mpoint = Geom::Point3d.new $a_LOrigin.x, $a_LOrigin.y+($v_LDepth/2), $a_LOrigin.z				
				tr=Geom::Transformation.scaling mpoint,1,-1,1
				@kicker_group.transform!(tr)
			end #end if
			#If it turns out that both are on then copy the kicker group and then mirror the copy to the inside
			if($s_KOutOn == "YES") and ($s_KInOn =="YES")
				@kicker2_group=@kicker_group.copy
				@kicker2_group.name = "Kicker In"
				mpoint = Geom::Point3d.new $a_LOrigin.x, $a_LOrigin.y+($v_LDepth/2), $a_LOrigin.z				
				tr=Geom::Transformation.scaling mpoint,1,-1,1
				@kicker2_group.transform!(tr)
			end #end if
		end #end if
							
		#Create the Name Plate
		#only create the nameplate if the panelstyle is none
		if($s_PanelStyle == "None")
			if($s_NOutOn == "YES") or ($s_NInOn == "YES")
			
				@nplate_entities = @model.active_entities
				@nplate_group = @leaf_entities.add_group
				@nplate_entities = @nplate_group.entities
				@nplate_group.name = "NamePlate Out"
			
				pts = Array.new(4) { $a_LOrigin.clone }
				pts[0].x += (@v_LWidth/2)-(@v_NWidth/2)
				#pts[0].y += $v_LDepth
				pts[0].z += @v_LHeight-@v_NFromTop-@v_NHeight
				pts[1].x += (@v_LWidth/2)-(@v_NWidth/2)
				#pts[1].y += $v_LDepth
				pts[1].z += @v_LHeight-@v_NFromTop
				pts[2].x += (@v_LWidth/2)+(@v_NWidth/2)
				#pts[2].y += $v_LDepth
				pts[2].z += @v_LHeight-@v_NFromTop
				pts[3].x += (@v_LWidth/2)+(@v_NWidth/2)
				#pts[3].y += $v_LDepth
				pts[3].z += @v_LHeight-@v_NFromTop-@v_NHeight
				#create face from points
				base = @nplate_entities.add_face(pts)
				base=base.reverse!
				#Paint
				if($s_UseMaterials == "YES") then base.material = @s_NMaterial end
				# Now we can do the pushpull
				base.pushpull(@v_NThick)
	
				if($s_NOutOn == "NO") and ($s_NInOn =="YES")
					@nplate_group.name = "NamePlate In"
					mpoint = Geom::Point3d.new $a_LOrigin.x, $a_LOrigin.y+($v_LDepth/2), $a_LOrigin.z				
					tr=Geom::Transformation.scaling mpoint,1,-1,1
					@nplate_group.transform!(tr)
				end #end if
				
				if($s_NOutOn == "YES") and ($s_NInOn =="YES")
					@nplate2_group=@nplate_group.copy
					@nplate2_group.name = "NamePlate In"
					mpoint = Geom::Point3d.new $a_LOrigin.x, $a_LOrigin.y+($v_LDepth/2), $a_LOrigin.z				
					tr=Geom::Transformation.scaling mpoint,1,-1,1
					@nplate2_group.transform!(tr)
				end #end if
			end #end if
		end #end if
	
		
		#Create the Handle(s)
		#only create the handles if the leaf height is (a bit) taller than the handle height or the leaf is wide enough
		if ((@v_HFromG+@v_HFromEdge+@v_HFromEdge) < @v_LHeight) and (@v_LWidth>(@v_PanelWidth*2.3))

			#handle
			if($s_HOutStyle == "Handle") or ($s_HInStyle == "Handle")
				@handle_entities = @model.active_entities
				@handle_group = @leaf_entities.add_group
				@handle_entities = @handle_group.entities
				@handle_group.name = "Handle Out"
			
				#handle plate
					pt1 = [$a_LOrigin.x+@v_LWidth-@v_HFromEdge, $a_LOrigin.y-@v_HShaft1L, $a_LOrigin.z+@v_HFromG]
					vec = Geom::Vector3d.new(0,1,0)
					#create face
					circ = @handle_entities.add_circle(pt1, vec, (@v_HShaft1D/2), @v_HSegs)
					base = @handle_entities.add_face(circ)
					if($s_UseMaterials == "YES") then base.material = @s_HMaterial end
					base.pushpull(@v_HShaft1L)
					
				#handle shaft
					pt1 = [$a_LOrigin.x+@v_LWidth-@v_HFromEdge, $a_LOrigin.y-@v_HShaft1L-@v_HShaft2L, $a_LOrigin.z+@v_HFromG]
					vec = Geom::Vector3d.new(0,1,0)
					#create face
					circ = @handle_entities.add_circle(pt1, vec, (@v_HShaft2D/2), @v_HSegs)
					base = @handle_entities.add_face(circ)
					if($s_UseMaterials == "YES") then base.material = @s_HMaterial end
					base.pushpull(@v_HShaft2L)
		
				#handle....... handle!
					pts = Array.new(4) { $a_LOrigin.clone }
					pts[0].x += @v_LWidth-@v_HFromEdge+(@v_HHeight/2)-@v_HLength
					pts[0].y += -@v_HShaft1L-@v_HShaft2L-@v_HThick
					pts[0].z += @v_HFromG-(@v_HHeight/2)
					pts[1].x += @v_LWidth-@v_HFromEdge+(@v_HHeight/2)-@v_HLength
					pts[1].y += -@v_HShaft1L-@v_HShaft2L-@v_HThick
					pts[1].z += @v_HFromG+(@v_HHeight/2)
					pts[2].x += @v_LWidth-@v_HFromEdge+(@v_HHeight/2)
					pts[2].y += -@v_HShaft1L-@v_HShaft2L-@v_HThick
					pts[2].z += @v_HFromG+(@v_HHeight/2)
					pts[3].x += @v_LWidth-@v_HFromEdge+(@v_HHeight/2)
					pts[3].y += -@v_HShaft1L-@v_HShaft2L-@v_HThick
					pts[3].z += @v_HFromG-(@v_HHeight/2)
					#create face from points
					base = @handle_entities.add_face(pts)
					#Paint
					if($s_UseMaterials == "YES") then base.material = @s_HMaterial end
					# Now we can do the pushpull
					base.pushpull(@v_HThick)
					
					if($s_HOutStyle != "Handle") and ($s_HInStyle =="Handle")
						@handle_group.name = "Handle In"
						mpoint = Geom::Point3d.new $a_LOrigin.x, $a_LOrigin.y+($v_LDepth/2), $a_LOrigin.z				
						tr=Geom::Transformation.scaling mpoint,1,-1,1
						@handle_group.transform!(tr)
					end #end if
					
					if($s_HOutStyle == "Handle") and ($s_HInStyle =="Handle")
						@handle2_group=@handle_group.copy
						@handle2_group.name = "Handle In"
						mpoint = Geom::Point3d.new $a_LOrigin.x, $a_LOrigin.y+($v_LDepth/2), $a_LOrigin.z				
						tr=Geom::Transformation.scaling mpoint,1,-1,1
						@handle2_group.transform!(tr)
					end #end if
			end #end if
			
			#push plates
			if($s_HOutStyle == "Push Plate") or ($s_HInStyle == "Push Plate")
				@handle_entities = @model.active_entities
				@handle_group = @leaf_entities.add_group
				@handle_entities = @handle_group.entities
				@handle_group.name = "Handle Out"

					pts = Array.new(4) { $a_LOrigin.clone }
					pts[0].x += @v_LWidth-@v_HFromEdge-@v_HPplateW
					#pts[0].y += $v_LDepth
					pts[0].z += @v_HFromG-(@v_HPplateH/2)
					pts[1].x += @v_LWidth-@v_HFromEdge-@v_HPplateW
					#pts[1].y += $v_LDepth
					pts[1].z += @v_HFromG+(@v_HPplateH/2)
					pts[2].x += @v_LWidth-@v_HFromEdge
					#pts[2].y += $v_LDepth
					pts[2].z += @v_HFromG+(@v_HPplateH/2)
					pts[3].x += @v_LWidth-@v_HFromEdge
					#pts[3].y += $v_LDepth
					pts[3].z += @v_HFromG-(@v_HPplateH/2)
					#create face from points
					base = @handle_entities.add_face(pts)
					base=base.reverse!
					#Paint
					if($s_UseMaterials == "YES") then base.material = @s_HMaterial end
					# Now we can do the pushpull
					base.pushpull(@v_HPplateT)

					if($s_HOutStyle != "Push Plate") and ($s_HInStyle =="Push Plate")
						@handle_group.name = "Handle In"
						mpoint = Geom::Point3d.new $a_LOrigin.x, $a_LOrigin.y+($v_LDepth/2), $a_LOrigin.z				
						tr=Geom::Transformation.scaling mpoint,1,-1,1
						@handle_group.transform!(tr)
					end #end if
					
					if($s_HOutStyle == "Push Plate") and ($s_HInStyle =="Push Plate")
						@handle2_group=@handle_group.copy
						@handle2_group.name = "Handle In"
						mpoint = Geom::Point3d.new $a_LOrigin.x, $a_LOrigin.y+($v_LDepth/2), $a_LOrigin.z				
						tr=Geom::Transformation.scaling mpoint,1,-1,1
						@handle2_group.transform!(tr)
					end #end if
			end
			
			#Long Bar
			if($s_HOutStyle == "Long Bar") or ($s_HInStyle == "Long Bar")
				@handle_entities = @model.active_entities
				@handle_group = @leaf_entities.add_group
				@handle_entities = @handle_group.entities
				@handle_group.name = "Handle Out"

					@bracket_entities = @model.active_entities
					@bracket_group = @handle_entities.add_group
					@bracket_entities = @bracket_group.entities
					@bracket_group.name = "Handle Bracket"

					#handle plate
						pt1 = [$a_LOrigin.x+@v_LWidth-@v_HFromEdge, $a_LOrigin.y-@v_HShaft1L, $a_LOrigin.z+@v_HFromG+(@v_HLBarL/3)]
						vec = Geom::Vector3d.new(0,1,0)
						#create face
						circ = @bracket_entities.add_circle(pt1, vec, (@v_HShaft1D/2), @v_HSegs)
						base = @bracket_entities.add_face(circ)
						if($s_UseMaterials == "YES") then base.material = @s_HMaterial end
						base.pushpull(@v_HShaft1L)
						
					#handle shaft
						pt1 = [$a_LOrigin.x+@v_LWidth-@v_HFromEdge, $a_LOrigin.y-@v_HShaft1L-@v_HShaft2L, $a_LOrigin.z+@v_HFromG+(@v_HLBarL/3)]
						vec = Geom::Vector3d.new(0,1,0)
						#create face
						circ = @bracket_entities.add_circle(pt1, vec, (@v_HShaft2D/2), @v_HSegs)
						base = @bracket_entities.add_face(circ)
						if($s_UseMaterials == "YES") then base.material = @s_HMaterial end
						base.pushpull(@v_HShaft2L)
					
					#2nd barcket mirrored vertically about HFromG
						@bracket2_group=@bracket_group.copy
						@bracket2_group.name = "Handle Bracket"
						mpoint = Geom::Point3d.new $a_LOrigin.x, $a_LOrigin.y, $a_LOrigin.z+@v_HFromG				
						tr=Geom::Transformation.scaling mpoint,1,1,-1
						@bracket2_group.transform!(tr)
					
				#long bar
					pt1 = [$a_LOrigin.x+@v_LWidth-@v_HFromEdge, $a_LOrigin.y-@v_HShaft1L-@v_HShaft2L, $a_LOrigin.z+@v_HFromG-(@v_HLBarL/2)]
					vec = Geom::Vector3d.new(0,0,1)
					#create face
					circ = @handle_entities.add_circle(pt1, vec, (@v_HLBarD/2), @v_HSegs)
					base = @handle_entities.add_face(circ)
					if($s_UseMaterials == "YES") then base.material = @s_HMaterial end
					base.pushpull(@v_HLBarL)

				if($s_HOutStyle != "Long Bar") and ($s_HInStyle =="Long Bar")
					@handle_group.name = "Handle In"
					mpoint = Geom::Point3d.new $a_LOrigin.x, $a_LOrigin.y+($v_LDepth/2), $a_LOrigin.z				
					tr=Geom::Transformation.scaling mpoint,1,-1,1
					@handle_group.transform!(tr)
				end #end if

				if($s_HOutStyle == "Long Bar") and ($s_HInStyle =="Long Bar")
					@handle2_group=@handle_group.copy
					@handle2_group.name = "Handle In"
					mpoint = Geom::Point3d.new $a_LOrigin.x, $a_LOrigin.y+($v_LDepth/2), $a_LOrigin.z				
					tr=Geom::Transformation.scaling mpoint,1,-1,1
					@handle2_group.transform!(tr)
				end #end if
			end #end if
			
			
			
			if($s_HOutStyle == "Panic Bolt") or ($s_HInStyle == "Panic Bolt")
				@handle_entities = @model.active_entities
				@handle_group = @leaf_entities.add_group
				@handle_entities = @handle_group.entities
				@handle_group.name = "Handle Out"

					@bracket_entities = @model.active_entities
					@bracket_group = @handle_entities.add_group
					@bracket_entities = @bracket_group.entities
					@bracket_group.name = "Handle Bracket"

					#panic bolt bracket1
						pts = Array.new(6) { $a_LOrigin.clone }
						pts[0].x += @v_HFromEdge+@v_HFromEdge
						pts[0].y += -@v_HPanicO
						pts[0].z += @v_HFromG
						pts[1].x += @v_HFromEdge+@v_HFromEdge
						pts[1].y += -@v_HPanicO
						pts[1].z += @v_HFromG+@v_HPanicH-@v_HPanicD
						pts[2].x += @v_HFromEdge+@v_HFromEdge
						#pts[2].y += 
						pts[2].z += @v_HFromG+@v_HPanicH
						pts[3].x += @v_HFromEdge+@v_HFromEdge
						#pts[3].y += 
						pts[3].z += @v_HFromG+@v_HPanicH-@v_HPanicT
						pts[4].x += @v_HFromEdge+@v_HFromEdge
						pts[4].y += -@v_HPanicO+@v_HPanicT
						pts[4].z += @v_HFromG+@v_HPanicD
						pts[5].x += @v_HFromEdge+@v_HFromEdge
						pts[5].y += -@v_HPanicO+@v_HPanicT
						pts[5].z += @v_HFromG
						#create face from points
						base = @bracket_entities.add_face(pts)
						#Paint
						if($s_UseMaterials == "YES") then base.material = @s_HMaterial end
						base.pushpull(@v_HPanicT)
					
					#2nd barcket mirrored horizontally about mid leaf
						@bracket2_group=@bracket_group.copy
						@bracket2_group.name = "Handle Bracket"
						mpoint = Geom::Point3d.new $a_LOrigin.x+(@v_LWidth/2), $a_LOrigin.y, $a_LOrigin.z				
						tr=Geom::Transformation.scaling mpoint,-1,1,1
						@bracket2_group.transform!(tr)
										
				#panic bolt bar
					pt1 = [$a_LOrigin.x+@v_HFromEdge, $a_LOrigin.y-@v_HPanicO+(@v_HPanicT/2), $a_LOrigin.z+@v_HFromG]
					vec = Geom::Vector3d.new(1,0,0)
					#create face
					circ = @handle_entities.add_circle(pt1, vec, (@v_HPanicD/2), @v_HSegs)
					base = @handle_entities.add_face(circ)
					if($s_UseMaterials == "YES") then base.material = @s_HMaterial end
					base.pushpull(@v_LWidth-@v_HFromEdge-@v_HFromEdge)
					
					
					
					if($s_HOutStyle != "Panic Bolt") and ($s_HInStyle =="Panic Bolt")
						@handle_group.name = "Handle In"
						mpoint = Geom::Point3d.new $a_LOrigin.x, $a_LOrigin.y+($v_LDepth/2), $a_LOrigin.z				
						tr=Geom::Transformation.scaling mpoint,1,-1,1
						@handle_group.transform!(tr)
					end #end if
					
					if($s_HOutStyle == "Panic Bolt") and ($s_HInStyle =="Panic Bolt")
						@handle2_group=@handle_group.copy
						@handle2_group.name = "Handle In"
						mpoint = Geom::Point3d.new $a_LOrigin.x, $a_LOrigin.y+($v_LDepth/2), $a_LOrigin.z				
						tr=Geom::Transformation.scaling mpoint,1,-1,1
						@handle2_group.transform!(tr)
					end #end if
			end #end if
		end #end if



		#Rotate the leaf around its hinge point by the required angle
		point = Geom::Point3d.new $a_LOrigin.x, $a_LOrigin.y+$v_LDepth, $a_LOrigin.z
		vector = Geom::Vector3d.new 0,0,1
		tr=Geom::Transformation.rotation point, vector, $v_Langle
		@leaf_group.transform!(tr)

	
	end #end of dm_create_leaf

	#-----------------------------------------------------------------------------------------------
	def dm_create_swing
		@model.start_operation("Create Door Swing arc")
	
		#Create and set layer
		layers = @model.layers
		layers.add(@s_LayerSwing2)
		activelayer = @model.active_layer=layers[@s_LayerSwing2]
		layer=@model.active_layer
		
		@arc_entities = @model.active_entities
		@arc_group = @leafset_entities.add_group
		@arc_entities = @arc_group.entities
		@arc_group.name = @s_SwingGrpName
		
		#do it
		cpoint = Geom::Point3d.new $a_LOrigin.x, $a_LOrigin.y+$v_LDepth, $a_LOrigin.z+@v_SwingFromG
		vector = Geom::Vector3d.new 0,0,@v_SwingFromG+1
		radius=(@v_LWidth)
		norm=1,0,0
		
		case $s_SwingStyle
		when "Single Swing"
			arccurve = @arc_entities.add_arc(cpoint, norm, vector, radius, 0, @v_Rad90, @v_SwingSegs) 
		when "Double Swing"
			arccurve = @arc_entities.add_arc(cpoint, norm, vector, radius, -@v_Rad90, @v_Rad90, @v_SwingSegs) 
		end #end case
		
	end	#end of dm_create_swing

	#-----------------------------------------------------------------------------------------------
	def dm_add_paint
		@model = Sketchup.active_model
		materials = @model.materials
		
	#	ADD THE DOOR FRAME MATERIAL
		if ((materials["Door-Frame"] == nil) && (materials["<Door-Frame>"] == nil))
			dframe = materials.add("Door-Frame")
			dframe.color = [255,255,200]
		end
	
	#	ADD THE DOOR LEAF MATERIAL
		if ((materials["Door-Leaf"] == nil) && (materials["<Door-Leaf>"] == nil))
			dleaf=materials.add("Door-Leaf")
			dleaf.color=[255,230,200]
		end
	
	#	ADD THE DOOR FITTINGS MATERIAL
		if ($s_KInOn == "YES") or ($s_KOutOn == "YES") or ($s_HInStyle != "None") or ($s_HOutStyle != "None")	#dont create of not needed
			if ((materials["Door-Fittings"] == nil) && (materials["<Door-Fittings>"] == nil))
				dfittings=materials.add("Door-Fittings")
				dfittings.color=[220,220,220]
			end
		end
		
	#	ADD THE DOOR NAMEPLATE MATERIAL
		if ($s_NInOn == "YES") or ($s_NOutOn == "YES")	#dont create of not needed
			if ((materials["Door-Nameplate"] == nil) && (materials["<Door-Nameplate>"] == nil))
				dnameplate=materials.add("Door-Nameplate")
				dnameplate.color=[190,190,190]
			end
		end
	
	#	ADD THE DOOR GLASS MATERIAL
		if ($s_PanelStyle != "None")	#dont create of not needed
			if ((materials["Door-Glass"] == nil) && (materials["<Door-Glass>"] == nil))
				dglass=materials.add("Door-Glass")
				dglass.color=[97,106,142]
				dglass.alpha=0.6
			end
		end

	end # end of dm_add_paint
	
#-----------------------------------------------------------------------------------------------
end		#### END OF CLASS ####
#-----------------------------------------------------------------------------------------------



file_loaded("DoorMaker.rb")

# Copyright 2004, Rick Wilson 

# THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR
# IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.

# Name :          Windowizer 3.0b5
# Description :   makes storefront windows from selected quadrilaterals
# Author :        RW
# Usage :         select faces, set preferences,
#                 and POOF! - windows!
# Date :          16.Jul.2004
# Type :		tool
# History:
#			3.0b6 (6/22/2005) - fixed "edit" bug
#			3.0b5 (5/12/2005) - added support for multiple erase
#						  added drop-down material selection
#			3.0b4 (1/25/2005) - added "edit" function
#			3.0b3 (1/25/2005) - added "inherit" and "erase" functions
#			3.0b2 (1/24/2005) - added nonQuadrilateral simple windows
#						- added attribute handling
#			3.0b1	(1/20/2005) - added proportional rows/columns
#			2.3 (15.Dec.2004) - fixed bounded face verification bug
#			2.2 (15.Sep.2004) - fixed group/component bug
#			2.1 (17.Aug.2004) - fixed floating point bug in dialog box
#						- fixed context menu validation bug
#						- fixed selection validation bug
#			2.0 (12.Aug.2004) - added features: corner selections, non-bounded face support,
#						  multiple face support
#			1.1e(26.Jul.2004) - metric support
#			1.1d(23.Jul.2004) - new selection filters; added flush corner & floor windows
#			1.1c(23.Jul.2004) - revised the revision to correct 0 col/row glitch
#			1.1 (23.Jul.2004) - revised to correct vector bugs resulting in
#						  strange windows outside of frames
#			1.0 (16.Jul.2004) - first version

require 'sketchup.rb'
#require 'offset.rb'
#require 'arraysum.rb'
require 'getMaterials.rb'
require 'EntsGetAtt.rb'

class Array
	def sum
		x=nil
		0.upto(self.length-1) do |e|
			if ((self[e].class==Fixnum) || (self[e].class==Float))
				x = x + self[e] if x!=nil
				x = self[e] if x==nil
			end
		end
		return x
	end
end

class Sketchup::Face
	def offset(dist)
		pi=Math::PI
		if (not ((dist.class==Fixnum || dist.class==Float || dist.class==Length) && dist!=0))
			return nil
		end
		verts=self.outer_loop.vertices
		pts=[]
		0.upto(verts.length-1) do |a|
			vec1=(verts[a].position-verts[a-(verts.length-1)].position).normalize
			vec2=(verts[a].position-verts[a-1].position).normalize
			vec3=(vec1+vec2).normalize
			if vec3.valid?
				ang=vec1.angle_between(vec2)/2
				ang=pi/2 if vec1.parallel?(vec2)
				vec3.length=dist/Math::sin(ang)
				t=Geom::Transformation.new(vec3)
				if pts.length > 0
					if not (vec2.parallel?(pts.last.vector_to(verts[a].position.transform(t))))
						t=Geom::Transformation.new(vec3.reverse)
					end
				end
				pts.push(verts[a].position.transform(t))
			end
		end
		Sketchup.active_model.active_entities.add_face(pts)
	end
end

class Wdw
end

class Windowizer

def initialize
	@model = Sketchup.active_model
	@entities = @model.active_entities
	@materials=@model.materials
	if not defined? $framewidth
		$vPanes = nil
		$hPanes = nil
		$framewidth = 2.inch
		$frameheight = 2.inch
		$mullwidth = 2.inch
		$mullheight = 2.inch
		$frameinset = 4.inch
		$glassinset = 2.inch
		$framecolor = "DimGray"
		$glasscolor = "Blue Glass"
	end
	$allSame=nil if $allSame!="edit"
	add_paint()							#ADD DEFAULT PAINT COLORS IF NECESSARY
	activate
end

#	FIND THE INSET FACE

def find_face(face1,face2,discard)
	$face=nil
	face1edges=face1.edges
	face2edges=face2.edges
	0.upto(3) do |a|
		0.upto(3) do |b|
			if ((face1edges[a] != face2edges[b]) and (face1edges[a].common_face(face2edges[b]) != discard ))
				if ((face1edges[a].common_face(face2edges[b]) != face1) and (face1edges[a].common_face(face2edges[b]) != face2))
					if (face1edges[a].common_face(face2edges[b]))
						return face1edges[a].common_face(face2edges[b])
						#face = face1edges[a].common_face(face2edges[b])
					end
				end
			end
		end
	end
end

#	FIND THE LOWEST 2 POINTS ON THE SELCTED FACE

def find_lowPoints(face)
	fVerts=face.vertices
	low1=fVerts[0]
	low2=low1
	0.upto(3) do |a|
		fVertsZ1=fVerts[a].position[2]
		if (fVertsZ1 <= low2.position[2])
			low2=fVerts[a]
		end
		if (fVertsZ1 <= low1.position[2])
			low2=low1
			low1=fVerts[a]
		end
	end
	0.upto(3) do |a|
		edge=face.edges[a]
		if ((edge.used_by?(low1)) && (edge.used_by?(low2)))
			$lowE=a
		end
	end
end

#	PAINT THE INSET FACES

def insetPaint(face)
	$faceEdges = face.edges					#Select edges so we know where we've been
	if $glassinset != 0
		face.pushpull (- $glassinset)			#Inset the glass
		discard=$faceEdges[0].faces[0]		#These lines find the new inset face
		face1=$faceEdges[0].faces[1]			# |
		face2=$faceEdges[1].faces[1]			# |
		face=find_face(face1,face2,discard)		#_V____
		#HERE IS WHERE TO SET ATTRIBUTE FOR GLASS
	end
	face.material=$glasscolor				#Paint the new inset face
	face.attribute_dictionary("WindowizerPane", true)				#CREATE THE ATTRIBUTE DICTIONARY (AD) FOR THIS OBJECT
	face.set_attribute("WindowizerPane","Frame",$wName)				#ATTRIBUTES: Parent frame name
	face.set_attribute("WindowizerPane","Material",face.material.name)	#ATTRIBUTES: Glass Material
	face.delete_attribute("WindowizerFrame")
end

#	BEGIN THE MAIN ROUTINE

def activate
	s = @model.selection
	$ss=[]
	$unb=[]
	$bnd=[]
	$unbNQ=[]
	$bndNQ=[]
	$nonQuad=[]


#		CHECK THE SELECTIONS!

	0.upto(s.length-1) do |x|
		$ss.push(s[x]) if ((s[x].class == Sketchup::Face) && (s[x].edges.length == 4))
		$nonQuad.push(s[x]) if((s[x].class == Sketchup::Face) && (s[x].edges.length != 4))
	end

	s.clear
	return UI.messagebox("No faces selected") if ($ss.empty? && $nonQuad.empty?)
	@model.start_operation "Windowizer" if $allSame!="edit"

	if $ss.length>1
		same = UI.messagebox("Use same settings for all quadrilateral faces?", MB_YESNO)
	else
		same=6
	end

	if not $ss.empty?
		if same==6
			$windowizerMode="edit" if $allSame=="edit"
			$allSame=true if $allSame!="edit"
			return nil if windowizer_settings().to_s=="end"
			$allSame=true if $allSame=="edit"
		end
	end

#	DO QUADRILATERAL FACES

#		CHECK FOR FACE-IN-A-FACE

	while $ss.length > 0
		bounded = nil
		ssEdges=$ss.first.edges
		0.upto(ssEdges.length-1) do |e|
			if ((ssEdges[e-1].faces == ssEdges[e].faces) && (ssEdges[e].faces.length == 2))
				bounded = true
			end
		end
		if bounded == true
			$bnd.push($ss.first)				#IS A FACE-IN-FACE
		else
			$unb.push($ss.first)				#NOT A FACE-IN-FACE
		end
		$ss.shift
	end

	$allSame=true if $allSame=="edit"
	$bnd.each {|bb| bounded(bb)}
	$unb.each {|bb| unbounded(bb)}
	$bnd=$unb=$ss=$allSame=nil
	@model.selection.clear
	@model.commit_operation if $allSame!="edit"

	@model.start_operation "windowizerNQ" if $allSame!="edit"
#	DO NON-QUADRILATERAL FACES

	if $nonQuad.length>1
		same = UI.messagebox("Use same settings for all non-quadrilateral faces?", MB_YESNO)
	else
		same=6
	end

	if not $nonQuad.empty?
		if same==6
			$allSame=true if $allSame!="edit"
			return nil if windowizer_settings().to_s=="end"
		end
	end

#		CHECK FOR FACE-IN-A-FACE

	while $nonQuad.length > 0
		bounded = nil
		ssEdges=$nonQuad.first.edges
		0.upto(ssEdges.length-1) do |e|
			if ((ssEdges[e-1].faces == ssEdges[e].faces) && (ssEdges[e].faces.length == 2))
				bounded = true
			end
		end
		if bounded == true
			$bndNQ.push($nonQuad.first)				#IS A FACE-IN-FACE
		else
			$unbNQ.push($nonQuad.first)				#NOT A FACE-IN-FACE
		end
		$nonQuad.shift
	end

	$allSame=true if $allSame=="edit"
	$bndNQ.each {|bb| boundedNQ(bb)}
	$unbNQ.each {|bb| unboundedNQ(bb)}
	$bndNQ=$unbNQ=$nonQuad=$allSame=nil
	@model.selection.clear
	@model.commit_operation if $allSame!="edit"
end

#		DEFAULT SETTINGS - PROMPT THE USER FOR THE WINDOWIZER SETTINGS

def windowizer_settings
	if $allSame=="edit"
		#puts $allSame.to_s + " - got to default settings section"
		if ((not defined? $vPanes) || ($vPanes==nil))
			$vPanes=2
			puts $vPanes
		end
		if ((not defined? $hPanes) || ($hPanes==nil))
			$hPanes=2 
			puts $hPanes
		end
	end
	if not $allSame=="edit"
		$vPanes=$vPanes.to_s if $vPanes.class==Fixnum
		$vPanes=$vPanes.join(",") if $vPanes.class==Array
		$hPanes=$hPanes.to_s if $hPanes.class==Fixnum
		$hPanes=$hPanes.join(",") if $hPanes.class==Array
		mats=getMaterials
		
		if $allSame == true
			enums = ['','','','','','','','',mats,mats]
			prompts = ["Rows", "Columns", "Frame Width", "Frame Height", "Mullion Width", "Mullion Height                              ", "Frame Inset", "Glass Inset", "Frame Color", "Glass Color"]
			values = [$vPanes, $hPanes, $framewidth, $frameheight, $mullwidth, $mullheight, $frameinset, $glassinset, $framecolor, $glasscolor]
			results = inputbox prompts, values, enums, "Windowizer Settings"
		else
			enums = ['','','','','','','',mats,mats]
			prompts = ["Rows", "Columns", "Frame Width", "Frame Height", "Mullion Width", "Mullion Height                              ", "Glass Inset", "Glass Color"]
			values = [$vPanes, $hPanes, $framewidth, $frameheight, $mullwidth, $mullheight, $glassinset, $glasscolor]
			results = inputbox prompts, values, enums, "Windowizer Settings"
		end
		if not results
			return "end"
		end	
	
		if $allSame == true
			$vPanes,$hPanes,$framewidth,$frameheight,$mullwidth,$mullheight,$frameinset,$glassinset,$framecolor,$glasscolor=results
		else
			$vPanes,$hPanes,$framewidth,$frameheight,$mullwidth,$mullheight,$glassinset,$glasscolor=results
		end
	end
#				CHECK PANES VARIABLES FOR ARRAYS

	if $vPanes.class == String
		if (not $vPanes.index(','))
			$vPanes=$vPanes.to_i
		else
			$vPanes=$vPanes.split(',')
			0.upto($vPanes.length-1) do |p|
				$vPanes[p]=$vPanes[p].to_i
				$vPanes[p]=1 if $vPanes[p]==0
			end
		end
	else
		($vPanes=1 if $vPanes<1) if $vPanes.class != Array
	end
	if $hPanes.class == String
		if (not $hPanes.index(','))
			$hPanes=$hPanes.to_i
		else
			$hPanes=$hPanes.split(',')
			0.upto($hPanes.length-1) do |p|
				$hPanes[p]=$hPanes[p].to_i
				$hPanes[p]=1 if $hPanes[p]==0
			end
		end
	else
		($hPanes=1 if $hPanes<1) if $hPanes.class != Array
	end

	if $vPanes.class==Fixnum
		$vPanes=1 if $vPanes<1
	end
	if $hPanes.class==Fixnum
		$hPanes=1 if $hPanes<1
	end

	$framewidth = 0.25.inch if $framewidth <= 0.inch
	$frameheight = 0.25.inch if $frameheight <= 0.inch
	$mullwidth = 0.25.inch if $mullwidth <= 0.inch
	$mullheight = 0.25.inch if $mullheight <= 0.inch
#	$frameinset = 0.5.inch if $frameinset == 0.inch
#	$glassinset = 0.5.inch if $glassinset == 0.inch
end

#		ADD THE DEFAULT PAINTS

def add_paint()

#		ADD THE GLASS PAINT

	if ((@materials["Blue Glass"] == nil) && (@materials["<Blue Glass>"] == nil))
		glass=@materials.add("Blue Glass")
		glass.color=[162,163,196]
		glass.alpha=0.6
	end

#		ADD THE FRAME PAINT

	if (@materials["DimGray"] == nil)
		frame=@materials.add("DimGray")
		frame.color="DimGray"
	end
end

# START BOUNDED FACE OPERATIONS

def bounded(face)
	if not $allSame
		Sketchup.active_model.selection.clear
		Sketchup.active_model.selection.add(face)
		prompts=["Frame Inset", "Frame Color"]
		values =[$frameinset, $framecolor]
		results=inputbox prompts, values, "Windowizer Settings"
		return nil if not results
		$frameinset = results[0]
		$framecolor = results[1]
	end
 	if $frameinset != 0
		$faceEdges = face.edges					#Select edges so we know where we've been
		face.pushpull (-$frameinset)	#Inset the frame
		$face_Edges = []
		0.upto($faceEdges.length-1) do |a|
			$face_Edges[$face_Edges.length]=$faceEdges[a] if ($faceEdges[a].valid?)	#Pass valid edges to new handler
		end

#FIX THIS SECTION FOR RARE INSTANCES THAT A 3-EDGE-BOUNDED FACE DOESN'T SELECT PROPERLY
#		face=nil
#		discard=$face_Edges[0].faces[0]				#These lines find the new inset face
#		face1=$face_Edges[0].faces[1]				# |
#		face2=$face_Edges[1].faces[1]				# |
#		face = nil							# |
#		face=find_face(face1,face2,discard)			#_V____
#END SECTION
#		0.upto($face_Edges.length-1) do |e|
#			if (($face_Edges[e-1].faces == $face_Edges[e].faces) && ($face_Edges[e].faces.length == 2))
#				discard = $face_edges[e-1].faces[0]
#			end
#		end
#END FIX THIS SECTION
		face=nil
		discard=$face_Edges[0].faces[0]				#These lines find the new inset face
		face1=$face_Edges[0].faces[1]				# |
		face2=$face_Edges[1].faces[1]				# |
		face = nil							# |
		face=find_face(face1,face2,discard)			#_V____
		face.attribute_dictionary("WindowizerFrame", true)		#CREATE THE ATTRIBUTE DICTIONARY (AD) FOR THIS OBJECT


	end
	$unb.push(face)
end

# START UNBOUNDED FACE OPERATIONS

def unbounded(face)
	frame=face
	if ($wName=frame.get_attributes("WindowizerFrame")["Name"])==nil
		$wName=Wdw.new.to_s.slice(6..14)
	end
	puts $wName
	if not $allSame
		@model.selection.clear
		@model.selection.add(face)
		return nil if windowizer_settings() == "end"
	end
	return if not face
	face.material=$framecolor				#PAINT THE NEW INSET FACE
	discard = nil
	discard = face						#THE INSET FACE IS NOW THE DISCARD FOR THE WINDOW PANES

	find_lowPoints(face)

	$edge1=face.edges[$lowE]				#PUT THE FACE EDGES IN A USABLE ORDER
	$edge2=face.edges[$lowE-3]
	$edge3=face.edges[$lowE-2]
	$edge4=face.edges[$lowE-1]

	if $hPanes.class==Fixnum
		$hLength1=($edge1.length-((2*$framewidth)+($mullwidth * ($hPanes - 1))))/$hPanes	#Glass length, bottom edge
		$hLength2=($edge3.length-((2*$framewidth)+($mullwidth * ($hPanes - 1))))/$hPanes	#Glass length, top edge
	else
		$hLength1=($edge1.length-((2*$framewidth)+($mullwidth * ($hPanes.length - 1))))/$hPanes.sum	#Glass length, bottom edge
		$hLength2=($edge3.length-((2*$framewidth)+($mullwidth * ($hPanes.length - 1))))/$hPanes.sum	#Glass length, top edge
	end
	if $vPanes.class==Fixnum
		$vLength1=($edge4.length-((2*$frameheight)+($mullheight * ($vPanes - 1))))/$vPanes	#Glass length, left edge
		$vLength2=($edge2.length-((2*$frameheight)+($mullheight * ($vPanes - 1))))/$vPanes	#Glass length, right edge
	else
		$vLength1=($edge4.length-((2*$frameheight)+($mullheight * ($vPanes.length - 1))))/$vPanes.sum	#Glass length, left edge
		$vLength2=($edge2.length-((2*$frameheight)+($mullheight * ($vPanes.length - 1))))/$vPanes.sum	#Glass length, right edge
	end

	if ($edge4.used_by?($edge1.start))
		$hpt1=Geom::Point3d.new($edge1.start.position)
	else
		$hpt1=Geom::Point3d.new($edge1.end.position)
	end

	0.upto(3) do |a|
		if (face.vertices[a].position == $hpt1)
			$hpt2=Geom::Point3d.new(face.vertices[a-3].position)
			$hpt3=Geom::Point3d.new(face.vertices[a-1].position)
			$hpt4=Geom::Point3d.new(face.vertices[a-2].position)
		end		
	end
	
	if ($edge1.start.position == $hpt1)
		$hVec1=$edge1.line[1]
	else
		$hVec1=$edge1.line[1].reverse
	end
	if ($edge3.start.position == $hpt4)	
		$hVec2=$edge3.line[1].reverse
	else
		$hVec2=$edge3.line[1]
	end
	if ($edge4.start.position == $hpt3)
		$vVec1=$edge4.line[1].reverse
	else
		$vVec1=$edge4.line[1]
	end
	if ($edge2.start.position == $hpt2)
		$vVec2=$edge2.line[1]
	else
		$vVec2=$edge2.line[1].reverse
	end

	if $vPanes.class==Fixnum
		$vP=$vPanes
	else
		$vP=$vPanes.length
	end
	if $hPanes.class==Fixnum
		$hP=$hPanes
	else
		$hP=$hPanes.length
	end
	$vStart1=$vStart2=0.0
	1.upto($vP) do |n|
 		$hStart1=$hStart2=0.0
		1.upto($hP) do |m|
			if $hPanes.class==Fixnum
				$hpt1x=$hpt1.offset($hVec1, ($framewidth+($mullwidth*(m-1))+($hLength1 * (m-1))))
				$hpt2x=$hpt1.offset($hVec1, ($framewidth+($mullwidth*(m-1))+($hLength1 * m)))
				$hpt3x=$hpt3.offset($hVec2, ($framewidth+($mullwidth*(m-1))+($hLength2 * (m-1))))
				$hpt4x=$hpt3.offset($hVec2, ($framewidth+($mullwidth*(m-1))+($hLength2 * m)))
			else
				$hpt1x=$hpt1.offset($hVec1, ($framewidth+($mullwidth*(m-1))+$hStart1))
				$hpt2x=$hpt1.offset($hVec1, ($framewidth+($mullwidth*(m-1))+$hStart1+($hLength1 * $hPanes[m-1])))
				$hpt3x=$hpt3.offset($hVec2, ($framewidth+($mullwidth*(m-1))+$hStart2))
				$hpt4x=$hpt3.offset($hVec2, ($framewidth+($mullwidth*(m-1))+$hStart2+($hLength2 * $hPanes[m-1])))

				$hStart1=$hStart1+($hLength1*$hPanes[m-1])
				$hStart2=$hStart2+($hLength2*$hPanes[m-1])
			end

			if $vPanes.class==Fixnum
				$vpt1x=$hpt1.offset($vVec1, ($frameheight+($mullheight*(n-1))+($vLength1 * (n-1))))	
				$vpt2x=$hpt1.offset($vVec1, ($frameheight+($mullheight*(n-1))+($vLength1 * n)))
				$vpt3x=$hpt2.offset($vVec2, ($frameheight+($mullheight*(n-1))+($vLength2 * (n-1))))
				$vpt4x=$hpt2.offset($vVec2, ($frameheight+($mullheight*(n-1))+($vLength2 * n)))
			else
				$vpt1x=$hpt1.offset($vVec1, ($frameheight+($mullheight*(n-1))+$vStart1))	
				$vpt2x=$hpt1.offset($vVec1, ($frameheight+($mullheight*(n-1))+$vStart1+($vLength1 * $vPanes[n-1])))
				$vpt3x=$hpt2.offset($vVec2, ($frameheight+($mullheight*(n-1))+$vStart2))
				$vpt4x=$hpt2.offset($vVec2, ($frameheight+($mullheight*(n-1))+$vStart2+($vLength2 * $vPanes[n-1])))
			end

			$line1=[Geom::Point3d.new($hpt1x), Geom::Point3d.new($hpt3x)]
			$line2=[Geom::Point3d.new($hpt2x), Geom::Point3d.new($hpt4x)]
			$line3=[Geom::Point3d.new($vpt1x), Geom::Point3d.new($vpt3x)]
			$line4=[Geom::Point3d.new($vpt2x), Geom::Point3d.new($vpt4x)]

			$pt0=Geom.intersect_line_line($line1, $line3)
			$pt1=Geom.intersect_line_line($line2, $line3)
			$pt2=Geom.intersect_line_line($line2, $line4)
			$pt3=Geom.intersect_line_line($line1, $line4)

			pts = []
			pts[0] = $pt0
			pts[1] = $pt1
			pts[2] = $pt2
			pts[3] = $pt3

			face = @entities.add_face pts
			insetPaint(face)
		end
		$vStart1=$vStart1+($vLength1*$vPanes[n-1])
		$vStart2=$vStart2+($vLength2*$vPanes[n-1])
	end
	if $vPanes.class==Array
		vPanes=$vPanes.join(",")
	else
		vPanes=$vPanes.to_s
	end
	if $hPanes.class==Array
		hPanes=$hPanes.join(",")
	else
		hPanes=$hPanes.to_s
	end
	frame.attribute_dictionary("WindowizerFrame", true)			#CREATE THE ATTRIBUTE DICTIONARY (AD) FOR THIS OBJECT
	frame.set_attribute("WindowizerFrame","Name",$wName)			#ATTRIBUTES: Name
	frame.set_attribute("WindowizerFrame","vPanes",vPanes)
	frame.set_attribute("WindowizerFrame","hPanes",hPanes)
	frame.set_attribute("WindowizerFrame","fWidth",$framewidth)
	frame.set_attribute("WindowizerFrame","fHeight",$frameheight)
	frame.set_attribute("WindowizerFrame","mWidth",$mullwidth)
	frame.set_attribute("WindowizerFrame","mHeight",$mullheight)
	frame.set_attribute("WindowizerFrame","fInset",$frameinset)
	frame.set_attribute("WindowizerFrame","gInset",$glassinset)
	frame.set_attribute("WindowizerFrame","fColor",$framecolor)
	frame.set_attribute("WindowizerFrame","gColor",$glasscolor)

end

def boundedNQ(face)
	frame=face
	$wName=Wdw.new.to_s
	$wName.slice!(6..14)
	puts $wName
	if not $allSame
		Sketchup.active_model.selection.clear
		Sketchup.active_model.selection.add(face)
		prompts=["Frame Inset", "Frame Color"]
		values =[$frameinset, $framecolor]
		results=inputbox prompts, values, "Windowizer Settings"
		return nil if not results
		$frameinset = results[0]
		$framecolor = results[1]
	end
 	if $frameinset != 0
		$faceEdges = face.edges					#Select edges so we know where we've been
		face.pushpull (-$frameinset)	#Inset the frame
		$face_Edges = []
		0.upto($faceEdges.length-1) do |a|
			$face_Edges[$face_Edges.length]=$faceEdges[a] if ($faceEdges[a].valid?)	#Pass valid edges to new handler
		end

		face=nil
		discard=$face_Edges[0].faces[0]				#These lines find the new inset face
		face1=$face_Edges[0].faces[1]				# |
		face2=$face_Edges[1].faces[1]				# |
		face = nil							# |
		face=find_face(face1,face2,discard)			#_V____
		face.attribute_dictionary("WindowizerFrame", true)			#CREATE THE ATTRIBUTE DICTIONARY (AD) FOR THIS OBJECT
		face.set_attribute("WindowizerFrame","Name",$wName)			#ATTRIBUTES: Name
		face.set_attribute("WindowizerFrame","vPanes",$vPanes)
		face.set_attribute("WindowizerFrame","hPanes",$hPanes)
		face.set_attribute("WindowizerFrame","fWidth",$framewidth)
		face.set_attribute("WindowizerFrame","fHeight",$frameheight)
		face.set_attribute("WindowizerFrame","mWidth",$mullwidth)
		face.set_attribute("WindowizerFrame","mHeight",$mullheight)
		face.set_attribute("WindowizerFrame","fInset",$frameinset)
		face.set_attribute("WindowizerFrame","gInset",$glassinset)
		face.set_attribute("WindowizerFrame","fColor",$framecolor)
		face.set_attribute("WindowizerFrame","gColor",$glasscolor)

	end
	$unbNQ.push(face)

end

def unboundedNQ(face)
#	UI.messagebox("Got here")
	$wName=Wdw.new
	if not $allSame
		@model.selection.clear
		@model.selection.add(face)
		return nil if windowizer_settings() == "end"
	end
	return if not face
	face.material=$framecolor				#PAINT THE NEW INSET FACE
	newface=face.offset(-$framewidth)
	insetPaint(newface)
	face.attribute_dictionary("WindowizerFrame", true)			#CREATE THE ATTRIBUTE DICTIONARY (AD) FOR THIS OBJECT
	face.set_attribute("WindowizerFrame","Name",$wName)			#ATTRIBUTES: Name
	face.set_attribute("WindowizerFrame","vPanes",$vPanes)
	face.set_attribute("WindowizerFrame","hPanes",$hPanes)
	face.set_attribute("WindowizerFrame","fWidth",$framewidth)
	face.set_attribute("WindowizerFrame","fHeight",$frameheight)
	face.set_attribute("WindowizerFrame","mWidth",$mullwidth)
	face.set_attribute("WindowizerFrame","mHeight",$mullheight)
	face.set_attribute("WindowizerFrame","fInset",$frameinset)
	face.set_attribute("WindowizerFrame","gInset",$glassinset)
	face.set_attribute("WindowizerFrame","fColor",$framecolor)
	face.set_attribute("WindowizerFrame","gColor",$glasscolor)

end

def Windowizer.edit
	begin
	puts "Edit mode"
	@model=Sketchup.active_model
	sel=@model.selection
	ents=@model.active_entities

	@model.start_operation "Windowizer Edit"

	wName=sel.first.get_attribute("WindowizerPane", "Frame")
	wName=sel.first.get_attribute("WindowizerFrame", "Name") if not wName
	$frame=[]
	ents.each {|e| $frame.push(e) if e.get_attribute("WindowizerFrame", "Name")==wName}
#	puts $frame
	$frame=$frame.first
	$tvPanes=$frame.get_attribute("WindowizerFrame","vPanes")
	$thPanes=$frame.get_attribute("WindowizerFrame","hPanes")
	$tframewidth=$frame.get_attribute("WindowizerFrame","fWidth")
	$tframeheight=$frame.get_attribute("WindowizerFrame","fHeight")
	$tmullwidth=$frame.get_attribute("WindowizerFrame","mWidth")
	$tmullheight=$frame.get_attribute("WindowizerFrame","mHeight")
	$tframeinset=$frame.get_attribute("WindowizerFrame","fInset")
	$tglassinset=$frame.get_attribute("WindowizerFrame","gInset")
	$tframecolor=$frame.get_attribute("WindowizerFrame","fColor")
	$tglasscolor=$frame.get_attribute("WindowizerFrame","gColor")

	$allSame="edit"
	if (UI.messagebox("Change to current settings?", MB_YESNO))==7
		mats=getMaterials
		prompts = ["Rows", "Columns", "Frame Width", "Frame Height", "Mullion Width", "Mullion Height          ", "Frame Inset", "Glass Inset", "Frame Color", "Glass Color"]
		values = [$tvPanes, $thPanes, $tframewidth, $tframeheight, $tmullwidth, $tmullheight, $tframeinset, $tglassinset, $tframecolor, $tglasscolor]
		enums = ['','','','','','','','',mats,mats]
		results = inputbox prompts, values, enums, "Change Current Window Settings"
		return nil if results==false
		$tvPanes,$thPanes,$tframewidth,$tframeheight,$tmullwidth,$tmullheight,$tframeinset,$tglassinset,$tframecolor,$tglasscolor=results

#					SAVE OLD SETTINGS
		vPanes=$vPanes
		hPanes=$hPanes
		framewidth=$framewidth
		frameheight=$frameheight
		mullwidth=$mullwidth
		mullheight=$mullheight
		frameinset=$frameinset
		glassinset=$glassinset
		framecolor=$framecolor
		glasscolor=$glasscolor
#					USE NEW SETTINGS
		$vPanes=$tvPanes
		$hPanes=$thPanes
		$framewidth=$tframewidth
		$frameheight=$tframeheight
		$mullwidth=$tmullwidth
		$mullheight=$tmullheight
		$frameinset=$tframeinset
		$glassinset=$tglassinset
		$framecolor=$tframecolor
		$glasscolor=$tglasscolor

		#sel.clear
		#sel.add($frame)
		#Windowizer.eraseOne
		Windowizer.erase
		sel.clear
		sel.add($frame)
		Windowizer.new

#					RESTORE OLD SETTINGS
		$allSame=nil
		$vPanes=vPanes
		$hPanes=hPanes
		$framewidth=framewidth
		$frameheight=frameheight
		$mullwidth=mullwidth
		$mullheight=mullheight
		$frameinset=frameinset
		$glassinset=glassinset
		$framecolor=framecolor
		$glasscolor=glasscolor
	else
		#sel.clear
		#sel.add($frame)
		#Windowizer.eraseOne
		Windowizer.erase
		sel.clear
		sel.add($frame)
		Windowizer.new
	end

	@model.commit_operation

rescue NoMethodError
	$stderr
	$allSame=nil
	raise
end
end


def Windowizer.inherit
	puts "Inherit mode"
	model=Sketchup.active_model
	ents=model.active_entities
	wName=model.selection.first.get_attribute("WindowizerPane", "Frame")
	wName=model.selection.first.get_attribute("WindowizerFrame", "Name") if not wName
	$frame=[]
	ents.each {|e| $frame.push(e) if e.get_attribute("WindowizerFrame", "Name")==wName}
#	puts $frame
	$frame=$frame.first
	$vPanes=$frame.get_attribute("WindowizerFrame","vPanes")
	$hPanes=$frame.get_attribute("WindowizerFrame","hPanes")
	$framewidth=$frame.get_attribute("WindowizerFrame","fWidth")
	$frameheight=$frame.get_attribute("WindowizerFrame","fHeight")
	$mullwidth=$frame.get_attribute("WindowizerFrame","mWidth")
	$mullheight=$frame.get_attribute("WindowizerFrame","mHeight")
	$frameinset=$frame.get_attribute("WindowizerFrame","fInset")
	$glassinset=$frame.get_attribute("WindowizerFrame","gInset")
	$framecolor=$frame.get_attribute("WindowizerFrame","fColor")
	$glasscolor=$frame.get_attribute("WindowizerFrame","gColor")

end


#def Windowizer.eraseOne
#	puts "EraseOne mode"
#	model=Sketchup.active_model
#	ents=model.active_entities
#	$ss=[]
#	edgeSet=[]
#	model.start_operation "Windowizer erase" if $allSame!="edit"
##				GET THE FRAME NAME FROM THE SELECTED PANE
#	wName=model.selection.first.get_attribute("WindowizerPane", "Frame")
#	wName=model.selection.first.get_attribute("WindowizerFrame", "Name") if not wName
##				GET ALL PANES W/ SAME PARENT FRAME
#	ents.each {|e| $ss.push(e) if e.get_attribute("WindowizerPane", "Frame")==wName}
#	puts $ss
##				GET ALL EDGES
#	$ss.each {|f| f.edges.each {|fe| fe.faces.each {|fef| edgeSet.push(fef.edges)}}}
#	edgeSet.flatten!.uniq!
##				ERASE EDGES
#	edgeSet.each {|e| e.erase!}
#	model.selection.clear
#	model.commit_operation if $allSame!="edit"
#end



def Windowizer.erase
	puts "Erase mode"
	model=Sketchup.active_model
	ents=model.active_entities
	sel=model.selection
	model.start_operation "Windowizer erase" if $allSame!="edit"
	wdws=[]
	sel.each {|se| wdws.push(se.get_attribute("WindowizerPane", "Frame"))}
	wdws.flatten!	
	wdws.uniq!
	wdws.delete(nil)
	for wName in wdws
		$ss=[]
		edgeSet=[]
#				GET ALL PANES W/ SAME PARENT FRAME
		ents.each {|e| $ss.push(e) if e.get_attribute("WindowizerPane", "Frame")==wName}
#		puts $ss
#				GET ALL EDGES
		$ss.each {|f| f.edges.each {|fe| fe.faces.each {|fef| edgeSet.push(fef.edges)}}}
		edgeSet.flatten!
		edgeSet.uniq!
#				ERASE EDGES
		edgeSet.each {|e| (e.erase! if e.valid?)}
		model.selection.clear
	end
	model.commit_operation if $allSame!="edit"
end



def Windowizer.validate_selection
	Sketchup.active_model.selection.each {|e| return true if e.class == Sketchup::Face}
	return nil
end

def Windowizer.validate_selection2
	return nil if Sketchup.active_model.selection.length > 1
	return true if not Sketchup.active_model.selection.first.attribute_dictionary("WindowizerPane")==nil
	return true if not Sketchup.active_model.selection.first.attribute_dictionary("WindowizerFrame")==nil
	return nil
end

def Windowizer.validate_selection3
	for e in Sketchup.active_model.selection
		return true if not e.attribute_dictionary("WindowizerPane")==nil
		return true if not e.attribute_dictionary("WindowizerFrame")==nil
	end
	return nil
end

end	#END CLASS WINDOWIZER

if( not file_loaded?("windowizer.rb") )
	UI.add_context_menu_handler do |menu|
		menu.add_separator
		submenu=menu.add_submenu("Windowizer")
			submenu.add_item("Windowize") { Windowizer.new } if (Windowizer.validate_selection)
			submenu.add_item("Edit Window") { Windowizer.edit } if (Windowizer.validate_selection2)
			submenu.add_item("Inherit Settings") { Windowizer.inherit } if (Windowizer.validate_selection2)
			submenu.add_separator if (Windowizer.validate_selection3)
			submenu.add_item("Erase Window") { Windowizer.erase } if (Windowizer.validate_selection3)
	end
end
#-----------------------------------------------------------------------------
file_loaded("windowizer.rb")


#if not file_loaded?("windowizer.rb")

#end
#
#-----------------------------------------------------------------------------
#file_loaded("windowizer.rb")



# ---------------------------------------------------------------------------
# Menu items:
#----------------------------------------------------------------------------
  Furnishing_menu = UI.menu("Plugins").add_submenu("Insert Furnishing")
  Furnishing_menu.add_item("Cab") { create_cab }
  Furnishing_menu.add_separator()
  Furnishing_menu.add_item("SimpleBeam") { createSimpleBeam }
  Furnishing_menu.add_item("SimplePly") { createSimplePly }
  Furnishing_menu.add_separator()
  Furnishing_menu.add_separator if (Windowizer.validate_selection)
  Furnishing_menu.add_item("Windowizer") { Windowizer.new } if (Windowizer.validate_selection)
  Furnishing_menu.add_separator()
  Furnishing_menu.add_item("Door Maker") {Sketchup.active_model.select_tool DM_Create.new }

